######################
#
#    Meganizer - Media Organzier is a media management software
#    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
######################

IF(UNIX)
	FIND_PROGRAM(RM_EXECUTABLE
		NAMES rm
		PATHS /usr/bin /bin
		NO_DEFAULT_PATH
	)
ELSE(UNIX)
	FIND_PROGRAM(RM_EXECUTABLE
		NAMES del
		PATHS c:/Windows/System
		NO_DEFAULT_PATH
	)
ENDIF(UNIX)

MACRO (CLEAN_GCDA_FILES)
	IF(NOT IS_ABSOLUTE ${RM_EXECUTABLE})
		MESSAGE("Skipping *.gcda cleanup, because RM_EXECUTABLE is not found")
	ELSE(NOT IS_ABSOLUTE ${RM_EXECUTABLE})
		MESSAGE("Cleanup *.gcda")
		FILE(GLOB_RECURSE gcda_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.gcda")
		FOREACH(_current_FILE ${gcda_FILES})
			EXECUTE_PROCESS(COMMAND ${RM_EXECUTABLE} "${_current_FILE}" WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
		ENDFOREACH (_current_FILE)
	ENDIF(NOT IS_ABSOLUTE ${RM_EXECUTABLE})
ENDMACRO (CLEAN_GCDA_FILES)

# for i in $(find -iname '*\.gcda'); do rm $i; done