/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumevaluationwidgetdesignerplugin.h"

#include "mediumevaluationwidget.h"

MediumEvaluationWidgetDesignerPlugin::MediumEvaluationWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumEvaluationWidgetDesignerPlugin::name() const
{
	return "MediumEvaluationWidget";
}

QString MediumEvaluationWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumEvaluationWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit evaluation of a medium";
}

QString MediumEvaluationWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumEvaluationWidgetDesignerPlugin::includeFile() const
{
	return "mediumevaluationwidget.h";
}

QIcon MediumEvaluationWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumEvaluationWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumEvaluationWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumEvaluationWidget(parent);
}

QString MediumEvaluationWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumEvaluationWidget\" name=\"evaluationWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumEvaluationWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumEvaluationWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumevaluationwidgetdesignerplugin.moc"
