/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumfileswidgetdesignerplugin.h"
#include "mediumfileswidgetdesignerplugin.moc"

#include <mediumfileswidget.h>

MediumFilesWidgetDesignerPlugin::MediumFilesWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumFilesWidgetDesignerPlugin::name() const
{
	return "MediumFilesWidget";
}

QString MediumFilesWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumFilesWidgetDesignerPlugin::toolTip() const
{
	return "The files edit widget provides a way to view and edit the files related to a medium";
}

QString MediumFilesWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumFilesWidgetDesignerPlugin::includeFile() const
{
	return "mediumfileswidget.h";
}

QIcon MediumFilesWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumFilesWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumFilesWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumFilesWidget(parent);
}

QString MediumFilesWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumFilesWidget\" name=\"keywordWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumFilesWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumFilesWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}
