/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumgenrewidgetdesignerplugin.h"

#include "mediumgenrewidget.h"

MediumGenreWidgetDesignerPlugin::MediumGenreWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumGenreWidgetDesignerPlugin::name() const
{
	return "MediumGenreWidget";
}

QString MediumGenreWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumGenreWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit genre of a medium";
}

QString MediumGenreWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumGenreWidgetDesignerPlugin::includeFile() const
{
	return "mediumgenrewidget.h";
}

QIcon MediumGenreWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumGenreWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumGenreWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumGenreWidget(parent);
}

QString MediumGenreWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumGenreWidget\" name=\"genreWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumGenreWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumGenreWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumgenrewidgetdesignerplugin.moc"
