/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumgiftwidgetdesignerplugin.h"

#include "mediumgiftwidget.h"

MediumGiftWidgetDesignerPlugin::MediumGiftWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumGiftWidgetDesignerPlugin::name() const
{
	return "MediumGiftWidget";
}

QString MediumGiftWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumGiftWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit gift stuff of a medium";
}

QString MediumGiftWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumGiftWidgetDesignerPlugin::includeFile() const
{
	return "mediumgiftwidget.h";
}

QIcon MediumGiftWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumGiftWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumGiftWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumGiftWidget(parent);
}

QString MediumGiftWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumGiftWidget\" name=\"giftWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumGiftWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumGiftWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumgiftwidgetdesignerplugin.moc"
