/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumkeywordwidgetdesignerplugin.h"
#include "mediumkeywordwidgetdesignerplugin.moc"

#include "mediumkeywordwidget.h"

MediumKeywordWidgetDesignerPlugin::MediumKeywordWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumKeywordWidgetDesignerPlugin::name() const
{
	return "MediumKeywordWidget";
}

QString MediumKeywordWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumKeywordWidgetDesignerPlugin::toolTip() const
{
	return "The keyword edit widget provides a way to view and edit the keywords related to a medium";
}

QString MediumKeywordWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumKeywordWidgetDesignerPlugin::includeFile() const
{
	return "mediumkeywordwidget.h";
}

QIcon MediumKeywordWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumKeywordWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumKeywordWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumKeywordWidget(parent);
}

QString MediumKeywordWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumKeywordWidget\" name=\"keywordWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumKeywordWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumKeywordWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}
