/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumliteraturewidgetdesignerplugin.h"

#include "mediumliteraturewidget.h"

MediumLiteratureWidgetDesignerPlugin::MediumLiteratureWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumLiteratureWidgetDesignerPlugin::name() const
{
	return "MediumLiteratureWidget";
}

QString MediumLiteratureWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumLiteratureWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit literature of a medium";
}

QString MediumLiteratureWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumLiteratureWidgetDesignerPlugin::includeFile() const
{
	return "mediumliteraturewidget.h";
}

QIcon MediumLiteratureWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumLiteratureWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumLiteratureWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumLiteratureWidget(parent);
}

QString MediumLiteratureWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumLiteratureWidget\" name=\"literatureWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumLiteratureWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumLiteratureWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumliteraturewidgetdesignerplugin.moc"
