/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumownerwidgetdesignerplugin.h"

#include "mediumownerwidget.h"

MediumOwnerWidgetDesignerPlugin::MediumOwnerWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumOwnerWidgetDesignerPlugin::name() const
{
	return "MediumOwnerWidget";
}

QString MediumOwnerWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumOwnerWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit owner's of a medium";
}

QString MediumOwnerWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumOwnerWidgetDesignerPlugin::includeFile() const
{
	return "mediumownerwidget.h";
}

QIcon MediumOwnerWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumOwnerWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumOwnerWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumOwnerWidget(parent);
}

QString MediumOwnerWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumOwnerWidget\" name=\"ownerWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumOwnerWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumOwnerWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumownerwidgetdesignerplugin.moc"
