/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumpersonswidgetdesignerplugin.h"

#include "mediumpersonswidget.h"

MediumPersonsWidgetDesignerPlugin::MediumPersonsWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumPersonsWidgetDesignerPlugin::name() const
{
	return "MediumPersonsWidget";
}

QString MediumPersonsWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumPersonsWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit persons of a medium";
}

QString MediumPersonsWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumPersonsWidgetDesignerPlugin::includeFile() const
{
	return "mediumpersonswidget.h";
}

QIcon MediumPersonsWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumPersonsWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumPersonsWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumPersonsWidget(parent);
}

QString MediumPersonsWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumPersonsWidget\" name=\"personsWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumPersonsWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumPersonsWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumpersonswidgetdesignerplugin.moc"
