/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumpricewidgetdesignerplugin.h"
#include "mediumpricewidgetdesignerplugin.moc"

#include <mediumpricewidget.h>

MediumPriceWidgetDesignerPlugin::MediumPriceWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumPriceWidgetDesignerPlugin::name() const
{
	return "MediumPriceWidget";
}

QString MediumPriceWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumPriceWidgetDesignerPlugin::toolTip() const
{
	return "The price edit field and label of a Medium";
}

QString MediumPriceWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumPriceWidgetDesignerPlugin::includeFile() const
{
	return "mediumpricewidget.h";
}

QIcon MediumPriceWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumPriceWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumPriceWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumPriceWidget(parent);
}

QString MediumPriceWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumPriceWidget\" name=\"boughtPriceWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumPriceWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumPriceWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}
