/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumwidgetdesignerplugin.h"

#include "mediumwidget.h"

MediumWidgetDesignerPlugin::MediumWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumWidgetDesignerPlugin::name() const
{
	return "MediumWidget";
}

QString MediumWidgetDesignerPlugin::group() const
{
	return "Graphics (Meganizer)";
}

QString MediumWidgetDesignerPlugin::toolTip() const
{
	return "Use it to display the main data of a medium in a graphical way";
}

QString MediumWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumWidgetDesignerPlugin::includeFile() const
{
	return "mediumwidget.h";
}

QIcon MediumWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumWidgetDesignerPlugin::isContainer() const
{
	return true;
}

QWidget* MediumWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumWidget(parent);
}

QString MediumWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumWidget\" name=\"mediumWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Preferred\" vsizetype=\"Preferred\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";;
}

void MediumWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumwidgetdesignerplugin.moc"
