/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumwishwidgetdesignerplugin.h"

#include "mediumwishwidget.h"

MediumWishWidgetDesignerPlugin::MediumWishWidgetDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	initialized = false;
}

QString MediumWishWidgetDesignerPlugin::name() const
{
	return "MediumWishWidget";
}

QString MediumWishWidgetDesignerPlugin::group() const
{
	return "Edit Media (Meganizer)";
}

QString MediumWishWidgetDesignerPlugin::toolTip() const
{
	return "Use it to show and edit wish status of a medium";
}

QString MediumWishWidgetDesignerPlugin::whatsThis() const
{
	return toolTip();
}

QString MediumWishWidgetDesignerPlugin::includeFile() const
{
	return "mediumwishwidget.h";
}

QIcon MediumWishWidgetDesignerPlugin::icon() const
{
	return QIcon();
}

bool MediumWishWidgetDesignerPlugin::isContainer() const
{
	return false;
}

QWidget* MediumWishWidgetDesignerPlugin::createWidget(QWidget* parent)
{
	return new MediumWishWidget(parent);
}

QString MediumWishWidgetDesignerPlugin::domXml() const
{
	return 	"<ui language=\"c++\">\n"
					"	<widget class=\"MediumWishWidget\" name=\"wishWidget\">\n"
					"		<property name=\"sizePolicy\">\n"
					"			<sizepolicy hsizetype=\"Expanding\" vsizetype=\"Expanding\">\n"
					"				<horstretch>0</horstretch>\n"
					"				<verstretch>0</verstretch>\n"
					"			</sizepolicy>\n"
					"		</property>\n"
					"	</widget>\n"
					"</ui>\n";
}

void MediumWishWidgetDesignerPlugin::initialize(QDesignerFormEditorInterface* core)
{
	Q_UNUSED(core);
	if(isInitialized())
		return;
	
	initialized = true;
}

bool MediumWishWidgetDesignerPlugin::isInitialized() const
{
	return initialized;
}

#include "mediumwishwidgetdesignerplugin.moc"
