/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "meganizerdesignerplugin.h"
#include "meganizerdesignerplugin.moc"

#include "mediumtitlewidgetdesignerplugin.h"
#include "mediummanufacturerwidgetdesignerplugin.h"
#include "mediumgenrewidgetdesignerplugin.h"
#include "mediumminwidgetdesignerplugin.h"
#include "mediumimagewidgetdesignerplugin.h"
#include "mediumpersonswidgetdesignerplugin.h"
#include "mediumdescriptionwidgetdesignerplugin.h"
#include "mediumevaluationwidgetdesignerplugin.h"
#include "mediumwishwidgetdesignerplugin.h"
#include "mediumliteraturewidgetdesignerplugin.h"
#include "mediumgiftwidgetdesignerplugin.h"
#include "mediumpricewidgetdesignerplugin.h"
#include "mediumloanwidgetdesignerplugin.h"
#include "mediumownerwidgetdesignerplugin.h"
#include "mediumkeywordwidgetdesignerplugin.h"
#include "mediumfileswidgetdesignerplugin.h"

#include "mediumwidgetdesignerplugin.h"

#include <QtPlugin>

MeganizerDesignerPlugin::MeganizerDesignerPlugin(QObject* parent)
	: QObject(parent)
{
	widgets << new MediumTitleWidgetDesignerPlugin(this);
	widgets << new MediumManufacturerWidgetDesignerPlugin(this);
	widgets << new MediumGenreWidgetDesignerPlugin(this);
	widgets << new MediumMinWidgetDesignerPlugin(this);
	widgets << new MediumImageWidgetDesignerPlugin(this);
	widgets << new MediumPersonsWidgetDesignerPlugin(this);
	widgets << new MediumDescriptionWidgetDesignerPlugin(this);
	widgets << new MediumEvaluationWidgetDesignerPlugin(this);
	widgets << new MediumWishWidgetDesignerPlugin(this);
	widgets << new MediumLiteratureWidgetDesignerPlugin(this);
	widgets << new MediumGiftWidgetDesignerPlugin(this);
	widgets << new MediumPriceWidgetDesignerPlugin(this);
	widgets << new MediumLoanWidgetDesignerPlugin(this);
	widgets << new MediumOwnerWidgetDesignerPlugin(this);
	widgets << new MediumKeywordWidgetDesignerPlugin(this);
	widgets << new MediumFilesWidgetDesignerPlugin(this);
	
	widgets << new MediumWidgetDesignerPlugin(this);
}

QList<QDesignerCustomWidgetInterface*> MeganizerDesignerPlugin::customWidgets() const
{
	return widgets;
}

Q_EXPORT_PLUGIN2(meganizerdesignerplugin, MeganizerDesignerPlugin)
