/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "designerplugintestconfig.h"
#include "designerplugintests.moc"

#include "designerplugintests.h"

#include <epluginloader.h>

class EModuleListWidgetItem;

#include <QtTest/QtTest>
#include <QDesignerCustomWidgetCollectionInterface>
#include <QDesignerCustomWidgetInterface>

void DesignerPluginTests::testPlugins()
{
	//load and test plugin
	EngSaS::ModuleListWidgetItems log;
	QList<QDesignerCustomWidgetCollectionInterface*> plugins = EPluginLoader<QDesignerCustomWidgetCollectionInterface>::loadPlugins(QString(LIBOUTDIR), log);
	
	if(plugins.size() == 0)
		QSKIP("Could not find designer plugin(s) at "+ QString(LIBOUTDIR).toLatin1(), SkipAll);
	
	foreach(QDesignerCustomWidgetCollectionInterface* plugin, plugins){
		QList<QDesignerCustomWidgetInterface*> widgets = plugin->customWidgets();
		foreach(QDesignerCustomWidgetInterface* widget, widgets)
			testPlugin(widget);
	}
	qDeleteAll(plugins);
}

void DesignerPluginTests::testPlugin(QDesignerCustomWidgetInterface* plugin)
{
	QVERIFY(plugin);
	plugin->initialize(0);
	QVERIFY(plugin->isInitialized());
	QVERIFY(!plugin->name().isEmpty());
	QVERIFY(!plugin->group().isEmpty());
	QVERIFY(!plugin->toolTip().isEmpty());
	QVERIFY(!plugin->whatsThis().isEmpty());
	QVERIFY(!plugin->includeFile().isEmpty());
// 	QVERIFY(!plugin->icon().isNull());
	QVERIFY(!plugin->domXml().isEmpty());
	
	QWidget *widget = plugin->createWidget(0);
	QVERIFY(widget);
	delete widget;
}


QTEST_MAIN(DesignerPluginTests)
