/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "buydata.h"

#include "medium.h"
#include "searchplugin.h"

BuyData::BuyData(){
  medium = 0;
  shop = 0;
  inCatalog = false;
  price = 0;
  isUsed = false;
  available = 0;
  shippingCost = 0;
}

bool BuyData::isValid()
{
	if ( !shop )
		return false;
	
	if ( !medium )
		return false;

	if ( !inCatalog )
		return false;
	
	if ( available  < 1 ) 
		return false;
	
	if ( price <= 0 )
		return false;
	
	return true;
}

bool BuyData::operator== ( const BuyData& data ) const
{
  if(data.medium == medium){
    if(data.shop == shop){
      if(data.inCatalog == inCatalog){
	if(data.price == price){
	  if(data.isUsed == isUsed){
	    if(data.available == available){
	      if(shippingCost == shippingCost){
		return true;
	      }
	    }
	  }
	}
      }
    }
  }
  return false;    
}

bool BuyData::operator!= ( const BuyData& data ) const
{
  if(operator==(data))
    return false;
  return true;
}
