/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "connectmediasearchdialog.h"
#include "connectmediasearchdialog.moc"

#include "connectmediasearch.h"
#include <epushbutton.h>

#include <QVBoxLayout>
#include <QHBoxLayout>

ConnectMediaSearchDialog::ConnectMediaSearchDialog(QWidget* parent, Qt::WindowFlags flags)
	: EDialog(parent, flags)
{
	setObjectName("ConnectMediaSearchDialog");
	setWindowTitle(tr("Connect Media Attributes"));
	
	QVBoxLayout *ml = new QVBoxLayout(this);
	setLayout(ml);
	
	widget = new ConnectMediaSearch(this);
	ml->addWidget(widget);
	connectByPass(widget);
	
	QHBoxLayout *bl = new QHBoxLayout();
	ml->addLayout(bl);
	
	EPushButton *button = new EPushButton(this);
	bl->addWidget(button);
	setHelp("keyword:Connect Search", button);
	
	bl->addStretch();
	
	button = new EPushButton(tr("Ok"), this);
	bl->addWidget(button);
	connect(button, SIGNAL(clicked()), this, SLOT(finish()));
	
	button = new EPushButton(tr("Cancel"), this);
	bl->addWidget(button);
	connect(button, SIGNAL(clicked()), this, SLOT(reject()));
}

void ConnectMediaSearchDialog::setPlugins(Medium* medium, SearchPlugin* searchPlugin)
{
	widget->setPlugins(medium, searchPlugin);
}

int ConnectMediaSearchDialog::exec()
{
	if(widget->checkSettings())
		return QDialog::Accepted;
	
	return QDialog::exec();
}

void ConnectMediaSearchDialog::finish()
{
	QString msg;
	if(widget->saveSettings(msg))
		accept();
}
