/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DELEGATESHOPPINGCART_H
#define DELEGATESHOPPINGCART_H

#include "libmeganizer.h"

#include <QStyledItemDelegate>

#include "searchplugin.h"

#include "mediumwidget.h"

class Medium;
class MediumWidget;
class MediaModel;

#include <QModelIndex>
#include <QMultiMap>

class LIBMEGANIZER_EXPORT DelegateShoppingCart : public QStyledItemDelegate
{
    Q_OBJECT
  public:
    DelegateShoppingCart ( MediaModel *model, QWidget* parent = 0 );
    virtual ~DelegateShoppingCart();

		void setMode(MediumWidget::Mode mode = MediumWidget::Standard);

    QSize sizeHint ( const QStyleOptionViewItem &option, const QModelIndex &index ) const;
    void paint ( QPainter *painter, const QStyleOptionViewItem &option,
                 const QModelIndex &index ) const;
    void setMaxWidth ( unsigned int maxWidth );
    /**
    	* set the quantity of medium at index "index" tp quantity
    	* @param quantity the quantity of medium at "index", if -1, the quantity is incremented by one
    	*/
    void setQuantity ( QModelIndex index, int quantity = -1 );
    void setQuantity ( Medium *medium, int quantity = -1 );
    void setBuyData ( QModelIndex index, BuyData data );
    void setBuyData ( Medium *medium, BuyData data );
    void clearBuyData();
    QMap<Medium*, BuyData> buyDataList();
		QMap<unsigned int, QString> mapCurrenciesList();
    void remove ( QModelIndex index );
    void remove ( Medium *medium );

  private:
    QMap<Medium*, int> mapQuantity;
    QMap<Medium*, BuyData> mapBuyData;
    QMap<unsigned int, QString> mapCurrencies;
    MediaModel *model;
		MediumWidget *paintWidget;
		MediumWidget::Mode myMode;
};

#endif // DELEGATESHOPPINGCART_H
