/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DETAILSWIDGET_H
#define DETAILSWIDGET_H

#include "libmeganizer.h"
#include <ewidget.h>

#include <QModelIndex>

class LIBMEGANIZER_EXPORT DetailsWidget : public EWidget
{
	Q_OBJECT
	public:
		DetailsWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		virtual ~DetailsWidget();
	
	public slots:
		virtual void setEnabled(bool show, QString defaultString = QString()) = 0;
		/**
			* @attention if nescassery, call setEnabled before, it should reset all content to nothing
			*/
		virtual void setItem(QModelIndex index) = 0;
		virtual void clear() = 0;
};

#endif // DETAILSWIDGET_H
