/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "detailswidgetnamedesc.h"
#include "detailswidgetnamedesc.moc"
#include "ui_detailswidgetnamedesc.h"

#include <QAbstractItemModel>

DetailsWidgetNameDesc::DetailsWidgetNameDesc(QWidget* parent, Qt::WindowFlags flags) 
	: DetailsWidget(parent, flags), ui(new Ui::DetailsWidgetNameDesc)
{
	nameColumn = -1;
	descColumn = -1;
	model = 0;
	
	ui->setupUi(this);
}

DetailsWidgetNameDesc::~DetailsWidgetNameDesc()
{

}

void DetailsWidgetNameDesc::setup(QAbstractItemModel* model, int nameColumn, int descColumn)
{
	this->model = model;
	
	this->nameColumn = nameColumn;
	this->descColumn = descColumn;
}

QString DetailsWidgetNameDesc::name()
{
	return ui->nameEdit->text();
}

QString DetailsWidgetNameDesc::description()
{
	return ui->descriptionEdit->toPlainText();
}

void DetailsWidgetNameDesc::setEnabled(bool show, QString defaultString)
{
	clear();
	if(!defaultString.isEmpty())
		ui->nameEdit->setText(defaultString);
	EWidget::setEnabled(show);
	ui->nameEdit->setFocus();
}

void DetailsWidgetNameDesc::setItem(QModelIndex index)
{
	clear();
	
	if(!model)
		return;
	
	if(!index.isValid())
		return;
	
	if((nameColumn < 0) || (model->columnCount() <= nameColumn))
		return;
	
	if((descColumn < 0)  || (model->columnCount() <= descColumn))
		return;

	ui->nameEdit->setText(model->data(model->index(index.row(), nameColumn)).toString());
	ui->descriptionEdit->setPlainText(model->data(model->index(index.row(), descColumn)).toString());
}

void DetailsWidgetNameDesc::clear()
{
	ui->nameEdit->setText("");
	ui->descriptionEdit->setPlainText("");
}
