/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DETAILSWIDGETNAMEDESC_H
#define DETAILSWIDGETNAMEDESC_H

#include "libmeganizer.h"
#include <detailswidget.h>

namespace Ui {
	class DetailsWidgetNameDesc;
};

#include <QModelIndex>
class QAbstractItemModel;

/**
	* @biref Provides an DetailsWidget with a name and a description edit field.
	*
	* The name is an QLineEdit and the description is a QPlainTextEdit.
	*/
class LIBMEGANIZER_EXPORT DetailsWidgetNameDesc : public DetailsWidget
{
	Q_OBJECT
	public:
		DetailsWidgetNameDesc(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		~DetailsWidgetNameDesc();
		/**
			* @param model The model which holds the data
			* @param nameColumn the column index of the column with the names
			* @param descColumn the column index of the column with the description
			*/
		void setup(QAbstractItemModel *model, int nameColumn, int descColumn);
		QString name();
		QString description();
		
	public slots:
		void setEnabled(bool show, QString defaultString);
		void setItem(QModelIndex index);
		void clear();
		
	private:
		QAbstractItemModel *model;
		int nameColumn, descColumn;
		Ui::DetailsWidgetNameDesc *ui;
};

#endif // DETAILSWIDGETNAMEDESC_H
