/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef EDITMANUFACTURERS_H
#define EDITMANUFACTURERS_H

#include "libmeganizer.h"
#include "editdialog.h"

class EditManufacturersDetailsWidget;

class QSqlQueryModel;
class QSortFilterProxyModel;

/**
  * @brief The editing and selection dialog of manufacturers.
  */
class LIBMEGANIZER_EXPORT EditManufacturers : public EditDialog
{
	Q_OBJECT
  public:
    EditManufacturers ( QString name, QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    EditManufacturers ( QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    ~EditManufacturers();
		QString selectedName();
		unsigned int selectedId();
    
  private slots:
		/**
			* @todo check and transform values to a standard format (e.g. website, phone numbers)
			*/
		void store();

  private:
    void init(QString selectName = QString());

    QSqlQueryModel *sqlModel;
    EditManufacturersDetailsWidget *myDetailsWidget;
};

#endif // EDITMANUFACTURERS_H
