/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef EDITMATERIALPERSONS_H
#define EDITMATERIALPERSONS_H

#include "libmeganizer.h"
#include "editdialog.h"

class MaterialPerson;

class EditMaterialPersonsDetailsWidget;

class QSqlQueryModel;

class QSortFilterProxyModel;

/**
  * @todo select not only with name, but also with givenName
	*/
class LIBMEGANIZER_EXPORT EditMaterialPersons : public EditDialog
{
	Q_OBJECT
	public:
		EditMaterialPersons ( QString name, QWidget *parent = 0, Qt::WindowFlags flags = 0 );
		EditMaterialPersons ( MaterialPerson *person, QWidget* parent = 0, Qt::WindowFlags flags = 0 );
		EditMaterialPersons ( QWidget *parent = 0, Qt::WindowFlags flags = 0 );
		~EditMaterialPersons();
		QString selectedName();
		QString selectedGivenName();
		unsigned int selectedId();

	private slots:
		void addNew();
		/**
			* @todo check and transform values to a standard format (e.g. website, phone numbers)
			*/
		void store();

	private:
		void init ( QString selectName = QString() );

		QSqlQueryModel *sqlModel;
		MaterialPerson *person;
		EditMaterialPersonsDetailsWidget *myDetailsWidget;
};

#endif // EDITMATERIALPERSONS_H
