/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef EDITUSER_H
#define EDITUSER_H

#include "libmeganizer.h"
#include <editdialog.h>

class EditUserDetailsWidget;

class QSqlQueryModel;

class LIBMEGANIZER_EXPORT EditUser : public EditDialog
{
	Q_OBJECT
	public:
		EditUser ( QString name, QWidget *parent = 0, Qt::WindowFlags flags = 0 );
		EditUser ( QWidget *parent = 0, Qt::WindowFlags flags = 0 );
		~EditUser();
		unsigned int selectedId();
		QString selectedName();
		QString selectedGivenName();
		
  protected:
    void store();
    void addNew();
		
	private:
		void init ( QString selectName = QString() );

    QSqlQueryModel *sqlModel;
    EditUserDetailsWidget *myDetailsWidget;
};

#endif // EDITUSER_H
