/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef EDITUSERDETAILSWIDGET_H
#define EDITUSERDETAILSWIDGET_H

#include "libmeganizer.h"

#include <detailswidget.h>

namespace Ui {
	class EditUserDetailsWidget;
};

class QSqlQueryModel;

class LIBMEGANIZER_EXPORT EditUserDetailsWidget : public DetailsWidget
{
	Q_OBJECT
  public:
		EditUserDetailsWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setModel(QSqlQueryModel *model);
		
	public slots:
    void clear();
    void setItem ( QModelIndex index );
    void setEnabled ( bool show, QString defaultString = QString() );
		
		bool store();
		void setId(unsigned int newId);
		unsigned int id();
		void setName(QString name);
		QString name();
		void setGivenName(QString name);
		QString givenName();
		void setUserName(QString name);
		QString userName();
		void setUserNameReadOnly(bool enable);
		void setUserNameNeeded();
		void setEmail(QString mail);
		QString email();
		
	private:
		QSqlQueryModel *model;
		unsigned int userId;
		bool userNameNeeded;
		Ui::EditUserDetailsWidget *ui;
};

#endif // EDITUSERDETAILSWIDGET_H
