/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DELEGATELOANSTATI_H
#define DELEGATELOANSTATI_H

#include <QStyledItemDelegate>
#include <QPainter>

class QSqlQueryModel;
class QTimer;

class DelegateLoanStati : public QStyledItemDelegate {
  Q_OBJECT
  public:
    DelegateLoanStati(QWidget *parent = 0);
		void paint(QPainter *painter, const QStyleOptionViewItem &option,
            const QModelIndex &index) const;
    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                       const QModelIndex &index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                   const QModelIndex &index) const;

  protected:

  private slots:
    void commitAndCloseEditor();
		void doCloseEditor();

  private:
		/**
			* the QString, int order is needed,
			* because the entries should be ordered after the string's
			*/
    QMap<QString, unsigned int> mapOutIn;
		QSqlQueryModel *resultModel;
		QTimer *timer;
};

#endif // DELEGATELOANSTATI_H
