/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DELEGATEMATERIALTYPES_H
#define DELEGATEMATERIALTYPES_H

#include <QStyledItemDelegate>

#include <QMap>

/**
	* @brief Displays the translated name instead the material type id.
	*
	* @note In paint() the usage of medium out of the index.internalPointer(),
	*   leads to segfaults. So the database query can not be omitted.
	*/
class DelegateMaterialTypes : public QStyledItemDelegate
{
	Q_OBJECT
	public:
		DelegateMaterialTypes(QWidget *parent = 0);
		
		void paint(QPainter* painter, const QStyleOptionViewItem& option, const QModelIndex& index) const;

	private:
		QMap<QString, unsigned int> mapTransToTypes;
};

#endif // DELEGATEMATERIALTYPES_H
