/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DELEGATEMIN_H
#define DELEGATEMIN_H

class MINValidator;

#include <QStyledItemDelegate>
#include <QPainter>
#include <QSqlQueryModel>

/**
  * Provides special handlings to validate the MIN and set the MIN type accordingly on first MIN set
  */
class DelegateMIN : public QStyledItemDelegate{
  Q_OBJECT
  public:
    /**
      * @param table the table where the foreignkey points to
      * @param matchColumn the column which is the same in showed table and foreignkey table (at table "table")
      * @param resultColumn the column at the foreignkey table which holds the content to be displayed
      */
    DelegateMIN(QWidget *parent = 0);
    ~DelegateMIN();
		
    void paint(QPainter *painter, const QStyleOptionViewItem &option,
            const QModelIndex &index) const;
    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                       const QModelIndex &index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                                 const QModelIndex &index) const;


  private slots:
    void commitAndCloseEditor();
		
	private:
		MINValidator *validator;
};

#endif // DELEGATEMIN_H
