/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef EDITMANUFACTURERSDETAILSWIDGET_H
#define EDITMANUFACTURERSDETAILSWIDGET_H

#include <detailswidget.h>
#include "ui_editmanufacturersdetailswidget.h"

class ManufacturerModel;

class QSqlQueryModel;

class EditManufacturersDetailsWidget : public DetailsWidget, private Ui::EditManufacturersDetailsWidget
{
	Q_OBJECT
	public:
		EditManufacturersDetailsWidget(QSqlQueryModel *model, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		QString name();
		
	public slots:
		bool store();
    void clear();
    void setItem(QModelIndex index);
    void setEnabled(bool show, QString defaultString = QString());
		
	private slots:
		void websiteFinished();
		/**
			* @brief Connect to nameEdit::editingFinished().
			* 
			* But only starts the search if curIndex is not valid and therefore
			* the actual manufacturer is an insert.
			*/
		void autoLoadData();
		void loadData();
		void loadDataRequestFinished(ManufacturerModel *resultModel);
		
	private:
		void loadDataCleanup();
		void showSendMINRangesMessage();
		
		QSqlQueryModel *model;
		QModelIndex curIndex;
		bool sendMINRanges;
};

#endif // EDITMANUFACTURERSDETAILSWIDGET_H
