/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "editmaterialpersonsdetailswidget.h"
#include "editmaterialpersonsdetailswidget.moc"

#include "materialperson.h"

#include <QSqlQueryModel>
#include <QSqlRecord>

EditMaterialPersonsDetailsWidget::EditMaterialPersonsDetailsWidget ( QSqlQueryModel *model, QWidget* parent, Qt::WindowFlags flags )
    : DetailsWidget ( parent, flags )
{
  this->model = model;

  setupUi ( this );
}

QString EditMaterialPersonsDetailsWidget::name()
{
  return nameEdit->text();
}

QString EditMaterialPersonsDetailsWidget::givenName()
{
  return givenNameEdit->text();
}

void EditMaterialPersonsDetailsWidget::clear()
{
  nameEdit->setText ( "" );
  givenNameEdit->setText ( "" );
}

void EditMaterialPersonsDetailsWidget::setItem ( QModelIndex index )
{
  if ( !model )
    return;

  if ( !index.isValid() )
    return;

  clear();

  QSqlRecord record = model->record ( index.row() );

  nameEdit->setText ( record.value ( "name" ).toString() );

  givenNameEdit->setText ( record.value ( "givenName" ).toString() );
}

void EditMaterialPersonsDetailsWidget::setEnabled ( bool show, QString defaultString )
{
  clear();

  if ( !defaultString.isEmpty() )
    nameEdit->setText ( defaultString );

	EWidget::setEnabled ( show );

  nameEdit->setFocus();
}

void EditMaterialPersonsDetailsWidget::setEnabled ( bool show, MaterialPerson *person )
{
  clear();

  if ( !person )
    return;

  nameEdit->setText(person->name());
  givenNameEdit->setText(person->givenName());
  
	EWidget::setEnabled ( show );

  nameEdit->setFocus();
}
