/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMMIN_H
#define MEDIUMMIN_H

#include <eobject.h>

class EQueryThread;

#include <QSqlRecord>
#include <QVariant>

/**
	* @brief A MIN itself.
	*/
class MediumMIN : public EObject
{
	Q_OBJECT
	public:
		MediumMIN(QString min, unsigned int typeId, unsigned int rowId = 0, EQueryThread *thread = NULL, QObject *parent = NULL);
		MediumMIN(QString min, QString type, unsigned int rowId = 0, EQueryThread *thread = NULL, QObject *parent = NULL);
		MediumMIN(EQueryThread *thread = NULL, QObject *parent = 0);

		void setThread(EQueryThread *thread);
		bool store(unsigned int materialId);
		void setRowId(unsigned int rowId);
		unsigned int rowId() const;
		bool prepareMIN();
		
		void setMIN(QString min);
		QString min() const;
		void setType(unsigned int id, bool setTypeName = true);
		void setType(QString name, bool setTypeId = true);
		void setType(QSqlRecord record);
		unsigned int type() const;
		QString typeName() const;
		
		void setMarkForRemovel( bool remove = true );
    bool markForRemovel() const;
		
		MediumMIN *copyMIN();
		
		bool operator== ( const MediumMIN &otherMin ) const;
		bool operator!= ( const MediumMIN &otherMin ) const;
		
	private slots:
		void queryResult(QObject *client, QVariant requestId, int querySize, QSqlRecord record);

	private:
		void init(EQueryThread *thread);
		bool insert(unsigned int materialId);
		bool remove(unsigned int materialId);
		
		unsigned int myTypeId, myRowId;
		QString myNumber, myTypeName;
		bool markedForRemovel;
		EQueryThread *thread;
		
	signals:
		void itemChanged(MediumMIN *object);
};

#endif // MEDIUMMIN_H
