/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "selectexportformat.h"
#include "selectexportformat.moc"

SelectExportFormat::SelectExportFormat(QMultiMap<QString, QStringList> formats, QWidget* parent, Qt::WindowFlags flags)
	: EDialog(parent, flags)
{
	setupUi(this);
	
	QStringList keys = formats.keys();
	foreach(QString key, keys){
		formatEdit->addItem(QString("%1 (*.%2)").arg(key).arg(formats.value(key).join("*.")));
	}
	
	connect(acceptButton, SIGNAL(clicked()), this, SLOT(accept()));
	connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
}

QString SelectExportFormat::selectedFormat()
{
	QString format = formatEdit->currentText();
	if(format.indexOf(" (*.") == -1){
		emit error(tr("Could not find selected format"));
		return QString();
	}
	format = format.left(format.indexOf(" (*."));
	return format;
}
