/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MANUFACTURER_H
#define MANUFACTURER_H

#include "libmeganizer.h"
#include <exmlitem.h>

class EXmlModel;

#include <QUrl>

/**
	* @brief A Manufacturer as defined in manuserver.xsd.
	*/
class LIBMEGANIZER_EXPORT Manufacturer : public EXmlItem
{
	public:
		Manufacturer(EXmlItem *parent = 0);

		static EXmlItem *create(EXmlModel*);
		static QString prepareWebsite(QString website);
		
		QVariant data(int column, int role = Qt::DisplayRole) const;
		bool load(QDomElement element, QMap< QString, EXmlParserItem* > parser);
		bool save(QDomElement& useElem);
		
		void setId(uint id);
		uint id() const;
		void setName(QString name);
		QString name() const;
		void setScore(uint score);
		uint score() const;
		void setStreet(QString street);
		QString street() const;
		void setNumber(QString number);
		QString number() const;
		void setCity(QString city);
		QString city() const;
		void setCountry(QString country);
		QString country() const;
		void setZIP(uint zip);
		uint zip() const;
		void setPostOfficeBox(uint box);
		uint postOfficeBox() const;
		void setWebsite(QString website);
		QUrl website() const;
		void setEmail(QString eMail);
		QString email() const;
		void setPhone(QString phone);
		QString phone() const;
		void setFax(QString fax);
		QString fax() const;
		
		EXmlItem* copy() const;
		
		bool loadFromDatabase(uint id);
    
	private:
		QString myName, myStreet, myNumber, myCity;
		QString myCountry, myEmail, myPhone, myFax;
		uint myId, myZIP, myPostOfficeBox, myScore;
		QUrl myWebsite;
};

#endif // MANUFACTURER_H
