/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MANUFACTURERMODELROOTITEM_H
#define MANUFACTURERMODELROOTITEM_H

#include "libmeganizer.h"
#include <exmlitem.h>

class EXmlModel;

class LIBMEGANIZER_EXPORT ManufacturerModelRootItem : public EXmlItem
{
	public:
		ManufacturerModelRootItem(QString tagName, EXmlItem *parent = 0);

		static EXmlItem *createManuServer(EXmlModel*);
		static EXmlItem *createSubmitPrefixes(EXmlModel*);
		static EXmlItem *createGetManufacturersByName(EXmlModel*);
		static EXmlItem *createGetManufacturersByPrefix(EXmlModel*);
		static EXmlItem *createResponse(EXmlModel*);
		
		QVariant data(int column, int role = Qt::DisplayRole) const;
		bool load(QDomElement element, QMap< QString, EXmlParserItem* > parser);
		bool save(QDomElement& useElem);
		
		void setName(QString name);
    QString name() const;
		void setPrefix(QString prefix);
		QString prefix() const;
		void setResult(QString text);
		bool result() const;
		void setMessage(QString message);
		QString message() const;
		
		EXmlItem* copy() const;
		
	private:
		QString myName, myPrefix, myMessage;
		bool myResult;
};

#endif // MANUFACTURERMODELROOTITEM_H
