/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MANUFACTURERPREFIX_H
#define MANUFACTURERPREFIX_H

#include "libmeganizer.h"
#include <exmlitem.h>

class EXmlModel;

/**
	* @brief A prefix as a child of Manufacturer like defined in manuserver.xsd.
	*/
class LIBMEGANIZER_EXPORT ManufacturerPrefix : public EXmlItem
{
	public:
		inline ManufacturerPrefix(EXmlItem *parent = 0) : EXmlItem("prefix", parent) { };
		
		static EXmlItem *create(EXmlModel*);
		
		QVariant data(int column, int role = Qt::DisplayRole) const;
		bool load(QDomElement element, QMap< QString, EXmlParserItem* > parser);
		bool save(QDomElement& useElem);
		
		void setType(QString type);
		QString type() const;
		void setPrefix(QString prefix);
		QString prefix() const;
		
		EXmlItem* copy() const;
		
	private:
		QString myType, myPrefix;
};

#endif // MANUFACTURERPREFIX_H
