/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MATERIALPERSONSMODEL_H
#define MATERIALPERSONSMODEL_H

#include "libmeganizer.h"
#include "personsmodel.h"

class MaterialPerson;
class EQueryThread;

class QAbstractItemView;

/**
	* @brief Handles MaterialPerson's.
	*
  * @todo implementing the changing of roles (use the id of the materialhaspersons table)
  */
class LIBMEGANIZER_EXPORT MaterialPersonsModel : public PersonsModel
{
  Q_OBJECT
  public:
    MaterialPersonsModel(EQueryThread *thread = NULL, QObject *parent = NULL);
    
    // own API
		using PersonsModel::addPerson;
    Person *addPerson();
		/**
			* adds a COPY of sourcePerson to the model
			*/
		bool addCopyOfPerson(MaterialPerson *sourcePerson);
		MaterialPerson *addPerson(QString name, QString givenName, QString role);
		MaterialPerson *addPerson(QString name, QString givenName, uint roleId);
		bool addPerson(uint personId, uint roleId, uint rowId = 0);
		bool addPerson(QSqlRecord record);
    bool store(uint materialId);
    bool loadAllPersons(uint materialId);
		void addItemDelegates(QAbstractItemView *view);
		MaterialPersonsModel *copyModel();
    
    // QT API
    QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
		bool setData ( const QModelIndex& index, const QVariant& value, int role = Qt::EditRole );
    int columnCount(const QModelIndex& parent = QModelIndex()) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
		Qt::ItemFlags flags(const QModelIndex& index) const;

	private:
		void customQueryResult(QVariant requestId, int querySize, QSqlRecord record);
};

#endif // MATERIALPERSONSMODEL_H
