/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MEDIUMCHILDSWIDGET_H
#define MEDIUMCHILDSWIDGET_H

#include "libmeganizer.h"
#include "mediumeditwidget.h"

class Medium;
class MediaModel;
class EListAddButton;
class EListRemoveButton;
class ETableView;

#include <QModelIndex>

/**
	* @brief Widget to display and edit the medium childs.
	*
	* @todo Use a copy of the original model and sync them
	*    in store().
	*/
class LIBMEGANIZER_EXPORT MediumChildsWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumChildsWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		bool store(bool useExistingTransaction = false);
		
	private slots:
		void addMedium();
		void addMedium(unsigned int mediumId);
		void removeMedium();
		void selectMedium(QModelIndex index);
		
	private:
		QModelIndex index;
		MediaModel *model;
		EListAddButton *addButton;
		EListRemoveButton *delButton;
		ETableView *view;
};

#endif // MEDIUMCHILDSWIDGET_H
