/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MEDIUMFILESWIDGET_H
#define MEDIUMFILESWIDGET_H

#include "mediumeditwidget.h"
#include "libmeganizer.h"

#include <efileinfo.h>

namespace Ui {
	class MediumFilesWidget;
}

#include <QMap>

class QListWidgetItem;

class LIBMEGANIZER_EXPORT MediumFilesWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumFilesWidget(QWidget *parent = NULL, Qt::WindowFlags flags = 0);
		
		bool store(bool useExistingTransaction = false);
		void setMedium(Medium* newMedium);

	private slots:
		void addFile();
		void removeFile();
		void openFile(QListWidgetItem *item);
		void openFile();

	private:
		Ui::MediumFilesWidget *ui;
		QMap<QString, EFileInfo> mapFiles;
		QList<EFileInfo> removedFiles;
};

#endif // MEDIUMFILESWIDGET_H
