/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMGIFTWIDGET_H
#define MEDIUMGIFTWIDGET_H

#include "libmeganizer.h"
#include "mediumeditwidget.h"

class Medium;
class PersonsModel;
class Person;

namespace Ui {
	class MediumGiftWidget;
};

#include <QModelIndex>

/**
	* @brief Class to display and edit gift status.
	*/
class LIBMEGANIZER_EXPORT MediumGiftWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumGiftWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		bool store(bool useExistingTransaction = false);
		
	private slots:
		void setGiftOnly();
		void addPresentees();
		void removePresentees();
		void presenteeContextMenu(QPoint pos);
		void giftGiven();
		void giftNotGiven();
		void userSelected(QModelIndex index);
		void userDoubleClicked(QModelIndex index);
		void presenteeSelected(QModelIndex index);
		void presenteeDoubleClicked(QModelIndex index);
	
	private:
		void init();

		Ui::MediumGiftWidget *ui;
		Medium *medium;
		PersonsModel *userModel, *presenteesModel;
		QModelIndex userIndex, presenteesIndex;
		QList<Person*> givenGift;
};

#endif // MEDIUMGIFTWIDGET_H
