/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumloandialog.h"
#include "mediumloandialog.moc"

#include "medium.h"
#include "mediumloanwidget.h"
#include <epushbutton.h>

#include <QHBoxLayout>
#include <QVBoxLayout>

MediumLoanDialog::MediumLoanDialog ( QWidget* widget, Qt::WindowFlags flags )
	: EDialog ( widget, flags )
{
	setupUi();
}

MediumLoanDialog::MediumLoanDialog ( Medium* medium, QWidget* widget, Qt::WindowFlags flags )
	: EDialog ( widget, flags )
{
	setupUi();
	setMedium(medium);
}

void MediumLoanDialog::setMedium ( Medium* medium )
{
	loanWidget->setMedium(medium);
}

void MediumLoanDialog::finish()
{
	if(loanWidget->store())
		accept();
}

void MediumLoanDialog::setupUi()
{
	setObjectName("mediumLoanDialog");
	setWindowTitle("Loan Manager");
	
	QVBoxLayout *mainLayout = new QVBoxLayout(this);
	setLayout(mainLayout);
	
	loanWidget = new MediumLoanWidget(this);
	mainLayout->addWidget(loanWidget);
	connectByPass(loanWidget);
	
	QHBoxLayout *bottomButtons = new QHBoxLayout();
	mainLayout->addLayout(bottomButtons);
	bottomButtons->addStretch();
	
	EPushButton *okButton = new EPushButton(tr("Ok"), this);
	bottomButtons->addWidget(okButton);
	connect(okButton, SIGNAL(clicked()), this, SLOT(finish()));
	
	EPushButton *cancelButton = new EPushButton(tr("Cancel"), this);
	bottomButtons->addWidget(cancelButton);
	connect(cancelButton, SIGNAL(clicked()), this, SLOT(reject()));
}
