/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
#ifndef MEDIUMLOANWIDGET_H
#define MEDIUMLOANWIDGET_H

#include "libmeganizer.h"
#include "mediumeditwidget.h"

class Medium;
class LoanModel;
class ETableView;

#include <QModelIndex>
class QPushButton;

/**
	* @todo handle medium changed() signal
	* @todo use LoanItem::validStati() to enable buttons
	*/
class LIBMEGANIZER_EXPORT MediumLoanWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumLoanWidget(QWidget *widget = 0, Qt::WindowFlags flags = 0);
		~MediumLoanWidget();
		void setMedium(Medium *medium);
		bool store(bool useExistingTransaction = false);
		
		/**
			* @return QStringList[0] - translated name of @p name
			* @return QStringList[1] - translated action related to @p name
			* @return QStringList[2] - translated description of @p name
			* @return if name is not found, an empty QStringList is returned
			*/
		static QStringList statiMap(QString name);
		
	private slots:
		void selectionChanged(QModelIndex index);
		void changeState();
		
	private:
		void setupUi();
		
		Medium *medium;
		LoanModel *model;
		QModelIndex index;
		unsigned int myUserId;
		QList<QPushButton*> buttonList;
		ETableView *loanStateView;
		/**
			* First QString (the key) is the untranslated name (stored in database).
			* The QStringList contains the translated name in first column,
			* the trunslated action in second column and
			* and the description in third column
			*/
};

#endif // MEDIUMLOANWIDGET_H
