/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumminwidget.h"
#include "mediumminwidget.moc"
#include "ui_mediumminwidget.h"

#include "medium.h"
#include "minmodel.h"
#include "editmintypes.h"
#include "mediummin.h"

#include <QHBoxLayout>
#include <QLabel>
#include <QLineEdit>
#include <QComboBox>

MediumMinWidget::MediumMinWidget(QWidget* parent, Qt::WindowFlags flags)
	: MediumEditWidget(parent, flags), ui(new Ui::MediumMinWidget)
{
	init();
	setMedium(NULL);
}

void MediumMinWidget::setMedium(Medium* medium)
{
	if(this->medium)
		medium->disconnect(this);
	this->medium = medium;
	
// 	if(medium)
// 		connect(medium, SIGNAL(changed()), this, SLOT(setMinFromMedium()));
		
	bool enable = true;
	if(!medium)
		enable = false;
	setEnabled(enable);

	if(medium){
		MINModel *model = medium->mins();
		model->setupView(ui->view);
	}
	setModified(false);
}

bool MediumMinWidget::store ( bool useExistingTransaction )
{
	Q_UNUSED(useExistingTransaction);
	// since we're only doing things on the model of the medium,
	// we do not need to store anything here.
	setModified(false);
	return true;
}

void MediumMinWidget::setDefaultMinType(unsigned int typeId)
{

}

void MediumMinWidget::setDefaultMinType(QString name)
{

}

void MediumMinWidget::setMin()
{
	if(!medium)
		return;
	
// 	medium->setMin(titleEdit->text());
}

void MediumMinWidget::newMIN()
{
	medium->mins()->addMIN();
	setModified();
}

void MediumMinWidget::removeMIN()
{
	QModelIndexList indexes = ui->view->selectionModel()->selectedIndexes();
	foreach(QModelIndex index, indexes){
		MediumMIN *min = medium->mins()->minFromIndex(index);
		min->setMarkForRemovel(true);
	}
	setModified();
}

void MediumMinWidget::newMINType()
{
	EditMinTypes editDia(this);
	connectByPass(&editDia);
	if(editDia.exec() == QDialog::Accepted)
		medium->mins()->reloadDelegates();
	editDia.disconnect(this);
	disconnect(&editDia);
}

void MediumMinWidget::selectionChanged(QModelIndex index)
{
	ui->removeButton->setDisabled(true);
	if(index.isValid())
		ui->removeButton->setEnabled(true);
}

void MediumMinWidget::init()
{
	this->medium = 0;
	defaultType = 0;
	ui->setupUi(this);
	
	ui->removeButton->setDisabled(true);

	connect(ui->newButton, SIGNAL(clicked()), this, SLOT(newMIN()));
	connect(ui->removeButton, SIGNAL(clicked()), this, SLOT(removeMIN()));
	connect(ui->newTypeButton, SIGNAL(clicked()), this, SLOT(newMINType()));
	connect(ui->view, SIGNAL(clicked(QModelIndex)), this, SLOT(selectionChanged(QModelIndex)));
}
