/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMMINWIDGET_H
#define MEDIUMMINWIDGET_H

#include "libmeganizer.h"

#include "mediumeditwidget.h"

class Medium;

namespace Ui {
	class MediumMinWidget;
};

class QLineEdit;
class QComboBox;

#include <QModelIndex>

/**
	* @brief Displays and allows to edit MINs.
	*
	* @todo Work on a copied model and sync the two models
	*   in store().
	*/
class LIBMEGANIZER_EXPORT MediumMinWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumMinWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		bool store(bool useExistingTransaction = false);
		void setDefaultMinType(unsigned int typeId);
		void setDefaultMinType(QString name);
		
	private slots:
		void setMin();
		void newMIN();
		void removeMIN();
		void newMINType();
		void selectionChanged(QModelIndex index);

	private:
		void init();
		
		Medium *medium;
		QLineEdit *minEdit;
		QComboBox *minType;
		unsigned int defaultType;
		Ui::MediumMinWidget *ui;
};

#endif // MEDIUMMINWIDGET_H
