/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMOWNERWIDGET_H
#define MEDIUMOWNERWIDGET_H

#include "libmeganizer.h"

#include <mediumeditwidget.h>

namespace Ui {
	class MediumOwnerWidget;
};

class Medium;
class PersonsModel;

#include <QModelIndex>

/**
	* @todo handle medium changed() signal
	* @todo reenable transactions @see MediumGiftWidget
	*/
class LIBMEGANIZER_EXPORT MediumOwnerWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumOwnerWidget(Medium *newMedium, QWidget *widget = 0, Qt::WindowFlags flags = 0);
		MediumOwnerWidget(QWidget *widget = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *newMedium);
		bool store(bool useOldTransaction = false);

	private slots:
		void ownerSelected(QModelIndex index);
		void ownerDoubleClicked(QModelIndex index);
		void userSelected(QModelIndex index);
		void userDoubleClicked(QModelIndex index);
		void addOwner();
		void removeOwner();
		
	private:
		void init();
		
		PersonsModel *ownerModel, *userModel;
		QModelIndex ownerIndex, userIndex;
		Ui::MediumOwnerWidget *ui;
};

#endif // MEDIUMOWNERWIDGET_H
