/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MEDIUMPARANTSWIDGET_H
#define MEDIUMPARANTSWIDGET_H

#include "libmeganizer.h"
#include "mediumeditwidget.h"

namespace Ui {
	class MediumParentsWidget;
};

class Medium;

/**
	* @brief Displays all media, which have the given medium as a child.
	*/
class LIBMEGANIZER_EXPORT MediumParentsWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumParentsWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *child);
		/**
			* Since ParentView is a read only class,
			* this function does nothing.
			*/
		bool store(bool useExistingTransaction = false);

	private:
		Ui::MediumParentsWidget *ui;
};

#endif // MEDIUMPARENTSWIDGET_H
