/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMPERSONSWIDGET_H
#define MEDIUMPERSONSWIDGET_H

#include "libmeganizer.h"

#include "mediumeditwidget.h"

class Medium;
class ETableView;
class EPushButton;

#include <QModelIndex>

/**
	* @brief Displays and allows to edit material persons.
	*
	* @todo Work on a copied model and sync the two models
	*   in store().
	*/
class LIBMEGANIZER_EXPORT MediumPersonsWidget : public MediumEditWidget
{
	Q_OBJECT
	public:
		MediumPersonsWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setDefaultRole(unsigned int roleId);
		void setMedium(Medium *medium);
		bool store(bool useExistingTransaction = false);
		
	private slots:
		void addPerson();
		void removePerson();
		void newRole();
		void clicked(QModelIndex index);
	
	private:
		void setupUi();
		
		Medium *medium;
		ETableView *personsView;
		EPushButton *removeButton;
		unsigned int defaultRole;
		QModelIndex index;
};

#endif // MEDIUMPERSONSWIDGET_H
