/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMPRICEWIDGET_H
#define MEDIUMPRICEWIDGET_H

#include "libmeganizer.h"
#include "mediumeditwidget.h"

class Medium;

namespace Ui {
	class MediumPriceWidget;
};

class QSqlQueryModel;

#include <QMap>
#include <QMetaType>

class LIBMEGANIZER_EXPORT MediumPriceWidget : public MediumEditWidget
{
	Q_OBJECT
	Q_PROPERTY(Price price READ price WRITE setPrice)
  Q_ENUMS(Price)
	public:
		/**
			* @brief The price which is displayed and edited.
			*
			* By default, the list price is used.
			*/
		enum Price {
			ListPrice,
			BoughtPrice
		};
		MediumPriceWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium *medium);
		bool store(bool useExistingTransaction = false);
		void setPrice(Price price);
		Price price() const;

	private:
		void init();
		void loadCompleter();

		Ui::MediumPriceWidget *ui;
		Medium *medium;
		QSqlQueryModel *complModel;
		QMap<unsigned int, QString> mapCurrencies;
		Price myPrice;
};

Q_DECLARE_METATYPE(MediumPriceWidget::Price);

#endif // MEDIUMPRICEWIDGET_H
