/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMWIDGET_H
#define MEDIUMWIDGET_H

#include "libmeganizer.h"
#include <ewidget.h>

#include <buydata.h>

class Medium;

#include <QPen>
#include <QBrush>
#include <QFont>
#include <QStyleOptionViewItem>

/**
	* Displays a Medium in a graphic way. It paints it equal to shoppingcartdelegate
	* @todo ShoppingCartDelegate should use this widget to paint stuff
	* @see ShoopingCartDelegate
	*/
class LIBMEGANIZER_EXPORT MediumWidget : public EWidget
{
	Q_OBJECT
	public:
		enum Mode { Standard, Extended, Shopping };
		
		MediumWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMode(Mode mode);
		void setMedium(Medium *medium);
		void setBuyData(BuyData buyData, unsigned int quantity);
		void paintMedium(QPainter *painter, const QStyleOptionViewItem &option);
		
		void setMaxWidth ( unsigned int maxWidth );
		QSize sizeHint ( ) const;
		
	protected slots:
		void paintEvent ( QPaintEvent *event );
		
	private:
		bool paintMedium(QPainter *painter, QRect drawInRect, QFont titleFont, QFont normalFont, QBrush backgroundBrush);
		QString truncateString ( QFontMetrics metrics, QString string, QRect rect ) const;
		
		Medium *medium;
		QPen borderPen, textPen;
    QBrush notFoundBrush, foundBrush, notEnoughBrush;
		unsigned int maxWidth, rowHeight, titleHeight, padding, margin;
		int quantity;
		BuyData buyData;
		Mode myMode;
};

#endif // MEDIUMWIDGET_H
