/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEGANIZERPLUGIN_H
#define MEGANIZERPLUGIN_H

#include "libmeganizer.h"
#include <eobject.h>

class QMenu;
class QAction;
class QToolBar;
class QDockWidget;
class QIcon;

/**
	* @brief The base class of Meganizer plugins.
	*
	* Do not implement it directly. Choose
	* MediaPlugin to provide new media types
	* or implement SearchPlugin to provide new
	* online sources.
	*
	* @see MediaPlugin
	* @see SearchPlugin
	*/
class LIBMEGANIZER_EXPORT MeganizerPlugin : public EObject
{
	public:
		virtual ~MeganizerPlugin() {};

		virtual bool initiate() = 0;
    virtual bool unload() = 0;
    virtual QString name() const = 0;
    virtual QIcon icon() const = 0;
    virtual QString description() const = 0;
};

Q_DECLARE_INTERFACE ( MeganizerPlugin,
											"Meganizer.MeganizerPlugin/0.4.0" );

#endif // MEGANIZERPLUGIN_H