/*
    Copyright (C) 2011  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MPLUGINLOADER_H
#define MPLUGINLOADER_H

#include "libmeganizer.h"

#include <epluginloader.h>
#include "libmeganizerconfig.h"

template <class PluginType>
class LIBMEGANIZER_EXPORT MPluginLoader {
	public:
		static QList<PluginType*> loadPlugins();
		static QList<PluginType*> loadPlugins(EngSaS::ModuleListWidgetItems &log);
		static PluginType* loadPlugin(QString name, EModuleListWidgetItem* item = 0);
};

template <class PluginType>
QList<PluginType*> MPluginLoader<PluginType>::loadPlugins()
{
	EngSaS::ModuleListWidgetItems log;
	return MPluginLoader<PluginType>::loadPlugins(log);
}

template <class PluginType>
QList<PluginType*> MPluginLoader<PluginType>::loadPlugins(EngSaS::ModuleListWidgetItems &log)
{
	return EPluginLoader<PluginType>::loadPlugins(QString(PLUGINDIR), log);
}

template <class PluginType>
PluginType* MPluginLoader<PluginType>::loadPlugin(QString name, EModuleListWidgetItem* item)
{
	return MPluginLoader<PluginType>::loadPlugin(name, item);
}

#endif // MPLUGINLOADER_H