/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "progressstatuswidget.h"
#include "progressstatuswidget.moc"
#include "ui_progressstatuswidget.h"

ProgressStatusWidget::ProgressStatusWidget(QWidget* parent, Qt::WindowFlags flags)
	: EWidget(parent, flags), ui(new Ui::ProgressStatusWidget)
{
	setAttribute(Qt::WA_DeleteOnClose, true);
	setObjectName("ProgressStatusWidget");
	myWasCanceled = false;
	ui->setupUi(this);
	connect(ui->cancelButton, SIGNAL(clicked()), this, SLOT(cancel()));
	ui->cancelButton->setIcon("process-stop", ":/icons/button_cancel.png");
}

bool ProgressStatusWidget::wasCanceled()
{
	return myWasCanceled;
}

void ProgressStatusWidget::setRange(int min, int max)
{
	ui->progressBar->setRange(min, max);
}

void ProgressStatusWidget::setRange(int max)
{
	setRange(0, max);
}

void ProgressStatusWidget::setValue(int value)
{
	ui->progressBar->setValue(value);
}

void ProgressStatusWidget::increaseValue()
{
	setValue(value() + 1);
}

int ProgressStatusWidget::value()
{
	return ui->progressBar->value();
}

void ProgressStatusWidget::setFormat(QString format)
{
	ui->progressBar->setFormat(format);
}

void ProgressStatusWidget::setLabel(QString text)
{
	ui->label->setText(text);
}

void ProgressStatusWidget::removeMe()
{
	if(sender())
		sender()->disconnect(this);
	close();
}

void ProgressStatusWidget::cancel()
{
	emit canceled();
	myWasCanceled = true;
}
