/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "sqlconstraint.h"

SqlConstraint::SqlConstraint()
{

}

bool SqlConstraint::isValid()
{
	if(myConstraint.isEmpty())
		return false;
	
	if(myBindValues.size() < 1)
		return false;
	
	return true;
}

QString SqlConstraint::constraint() const
{
	return myConstraint;
}

void SqlConstraint::setConstraint ( QString condition )
{
	myConstraint = condition;
}

QList< QVariant > SqlConstraint::bindValues() const
{
	return myBindValues;
}

void SqlConstraint::addBindValue ( QVariant value )
{
	myBindValues << value;
}

bool SqlConstraint::operator== ( const SqlConstraint& sqlConstraint ) const
{
	if(constraint() != sqlConstraint.constraint())
		return false;
	
	if(bindValues() != sqlConstraint.bindValues())
		return false;
	
	return true;
}

bool SqlConstraint::operator!= ( const SqlConstraint& sqlConstraint ) const
{
	return !operator==(sqlConstraint);
}

