/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef LOANMODELTEST_H
#define LOANMODELTEST_H

#include <QDate>

struct LoanedData {
	unsigned int mediumId;
	unsigned int ownerId;
	unsigned int recipientId;
	unsigned int loanStatus;
	QDate loanedUntil;
};

#include <QObject>

#include <dbtestinit.h>
class Medium;

#include <QPointer>

class LoanModelTest : public QObject
{
	Q_OBJECT
	private slots:
		void initTestCase();
		/**
			* @todo test setStatus
			*/
		void loanItemTest();
		void validStati_data();
		void validStati();
		/**
			* @todo empty ownerName not tested
			*/
		void loanedUntil_data();
		void loanedUntil();
		void loanStatus_data();
		void loanStatus();
		/**
			* Testing the normal loan mode with valid medium.
			*/
		void loanModelTest();
		/**
			* Testing the loanSummaryMode
			*/
		void loanSummaryTest();
		
	private:
		/**
			* @brief Inserts a new medium into the database and returns a pointer to the related object.
			*
			*/
		Medium *createNewMedium(unsigned int ownerId);
		bool storeLoanedData(LoanedData &data);
		
		QPointer<DBTestInit> testInit;
		MediumKeys keys;
		/**
			* dbUser1: Another user (first is into keys) with database access
			* user1: a user without database access
			*/
		unsigned int dbUser1, dbUser2, user1;
		QString dbUserName1, dbUserName2;
		LoanedData loanedNever, loanedBefore, loaned, loanedOver;
};

#endif // LOANMODELTEST_H
