/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "materialpersonsmodeltest.h"

#include <materialpersonsmodel.h>
#include <modeltest.h>
#include <materialperson.h>

#include <QtTest/QtTest>

MaterialpersonsModelTest::MaterialpersonsModelTest(QObject* parent): QObject(parent)
{
	model = new MaterialPersonsModel(NULL, this);
	modeltest = new ModelTest(model, this);
}

MaterialpersonsModelTest::~MaterialpersonsModelTest()
{
	delete modeltest;
	delete model;
}

void MaterialpersonsModelTest::testModel()
{
	QList<MaterialPerson*> items;
	items << new MaterialPerson();
	items << new MaterialPerson("Test", "My Test", "Unkown");
	items << new MaterialPerson("Test", "My Test", 111);
	items << new MaterialPerson(0, 0, 0);
	items << new MaterialPerson(5, 0);
	items << new MaterialPerson(5, 5);
	items << new MaterialPerson(10, 10, 10);
// 	
	// insert mins
	foreach(MaterialPerson *person, items)
		model->addPerson(person);

	QCOMPARE(model->rowCount(), items.size());

	// 	remove a min from the beginning, the middle and the end
	if(model->rowCount() > 0)
		model->removeRow(0);

	if(model->rowCount() > 0)
		model->removeRow(model->rowCount() - 1);

	if(model->rowCount() > 2){
		int half = model->rowCount() / 2;
		model->removeRow(half);
	}
}

QTEST_APPLESS_MAIN(MaterialpersonsModelTest)

#include "materialpersonsmodeltest.moc"
