/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MEDIUMEDITWIDGETTESTS_H
#define MEDIUMEDITWIDGETTESTS_H

#include <mediumeditwidgetbasetests.h>

/**
	* @brief Tests all MediumEditWidget's without the MediumSimpleEditWidget's.
	*
	* To add a new widget test, implement two static functions. One to do the modifications
	* at your MediumEditWidget class and one to check the storing of the made modifications.
	* Than add your widget and the callbacks to your static functions at the test_data() function.
	* The test() function executes all tests on your widget afterwards and executes your static
	* functions at appropriate places.
	*/
class MediumEditWidgetTests : public MediumEditWidgetBaseTests
{
	Q_OBJECT
	public:
		static bool ownerWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool ownerWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool childsWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool childsWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool imageWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool imageWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool priceWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool priceWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool evaluationWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool evaluationWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool keywordWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool keywordWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool personsWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool personsWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool giftWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool giftWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);

		static bool parentsWidgetModify(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget);
		static bool parentsWidgetCheck(MediumEditWidgetBaseTests *caller, MediumEditWidget *widget, Medium *med);
		
	private slots:
		void initTestCase();
		void test();
		
	private:
		bool addPerson(QString name, QString givenName, uint medId, uint roleId);
};

#endif // MEDIUMEDITWIDGETTESTS_H
