/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef MEDIUMTEST_H
#define MEDIUMTEST_H

#include <QObject>

#include <dbtestinit.h>

class Medium;

#include <QPointer>
#include <QVariant>

// to allow QTest::addColumn<QVariant>("")
Q_DECLARE_METATYPE(QVariant);

class MediumTest : public QObject
{
	Q_OBJECT
	private slots:
		void initTestCase();
		void fetchMessages(QString msg);
		
		void operators();
		void genre();
		void manufacturer();
		/**
			* set's and read's basic properties, without storing them to the database
			* Basic properties is stuff like wish, title, genre, manufacturer
			* and NOT persons, mins, ...
			*/
		void readAndSetBasicProperties();
		
		void copyMedium();
		/**
			* checks the same functions like the @see readAndSetBasicProperties(),
			* but it checks the storing and loading from database
			*/
		void insertAndLoadBasicProperties();
		/**
			* insert the same medium as another user
			*/
		void addOwner();
		/**
			* tests material persons handling
			*/
		void personsHandling();
		/**
			* test min behaviour
			*/
		void minHandling();
		
		/**
			* @todo check wether data set's the correct propertie (e.g. setValue("title", "asd"), check title() == "asd")
			* @todo add more test data
			*/
		void valueAndSetValueString_data();
		/**
			* test model api with attribute names
			*/
		void valueAndSetValueString();

		void keywords();
		
		void files();

		void childs();
		
	private:
		void connectMedium(Medium *med);
		
		QPointer<DBTestInit> testInit;
		MediumKeys keys;
		unsigned int testMedId;
};

#endif // MEDIUMTEST_H
