/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "personsmodeltest.h"
#include "personsmodeltest.moc"

#include <personsmodel.h>
#include "modeltest.h"
#include <person.h>

#include <QtTest/QtTest>
#include <QTableView>

PersonsModelTest::PersonsModelTest(QObject* parent): QObject(parent)
{
	model = new PersonsModel(NULL, this);
	modeltest = new ModelTest(model, this);
}

PersonsModelTest::~PersonsModelTest()
{
	delete modeltest;
	delete model;
}

void PersonsModelTest::testModel()
{
	QList<Person*> items;
	items << new Person();
	items << new Person("Test", "My Test");
	items << new Person(0, 0, NULL);
	items << new Person(100);
	
	// insert mins
	foreach(Person *person, items){
		model->addPerson(person);
	}
	
	QCOMPARE(model->rowCount(), items.size());
	
	// remove a min from the beginning, the middle and the end
	if(model->rowCount() > 0)
		model->removeRow(0);
	
	if(model->rowCount() > 0)
		model->removeRow(model->rowCount() - 1);
	
	if(model->rowCount() > 2){
		int half = model->rowCount() / 2;
		model->removeRow(half);
	}
}

QTEST_MAIN(PersonsModelTest)
