/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "mediumbasetests.h"
#include "mediumbasetests.moc"

#include <medium.h>
#include <editmedium.h>

#include <eclosemodalwidgetthread.h>

#include <QtTest/QtTest>

void MediumBaseTests::baseTests(Medium *med)
{
	QVERIFY(med);
	EditMedium *widget = med->editWidget();
	QVERIFY(widget);
	ECloseModalWidgetThread thread;
	thread.start();
	if(!thread.waitForStart())
		QSKIP("Could not start thread", SkipSingle);
	widget->exec();
	thread.stopThread();
 	widget->save();
	delete widget;

	// test the creation of new medium
	Medium *newMed = med->newMedium();
	QVERIFY(newMed);
	QCOMPARE(newMed->metaObject()->className(), med->metaObject()->className());
	delete newMed;
}
