<?php

class Settings{
	/**
		* @return the value of settings @p $settingName or empty string if nothing is found
		*/
	static public function value($settingName){
		$settings = Settings::prepareFile();
		if(empty($settings))
			return "";
		foreach(file($settings) as $line){
			$matches = array();
			if(preg_match("/[\s]{0,}([^\s]+)[\s]{0,}=/", $line, $matches)){
				if(strtolower($matches[1]) == strtolower($settingName)){
					$start = strpos($line, "=") + 1;
					$line = substr($line,  $start, strlen($line) - $start);
					return trim($line);
				}
			}
		}
		return "";
	}

	/**
		* saves @p $content to setting with name @p $settingName
		* if @p $settingName already exists, it's content is replaced with @p $content
		*/
	static public function setValue($settingName, $content){
		$settings = Settings::prepareFile();
		if(empty($settings))
			return false;

		$newFile = array();
		$found = false;
		foreach(file($settings) as $line){
			$matches = array();
			if(preg_match("/[\s]{0,}([^\s]+)[\s]{0,}=/", $line, $matches)){
				if(strtolower($matches[1]) == strtolower($settingName)){
					$found = true;
					array_push($newFile, strtoupper($matches[1]) ." = ". str_replace("\n", "", trim($content)));
				}
			}
			array_push($newFile, trim($line));
		}
		if(!$found){
			// settingName is not present, so append it
			array_push($newFile, strtoupper($settingName) ." = ". str_replace("\n", "", trim($content)));
		}

		// write new file
		$fd = @ fopen($settings, "w+");
		if($fd == false)
			return false;
		foreach($newFile as $line){
			fwrite($fd, trim($line) ."\n");
		}
		fclose($fd);
		return true;
	}

	/**
		* prepares the settings file and returns the file name, if preparation was successfull
		* @note should only be called by functions from this object
		*/
	static public function prepareFile() {
		$file = "settings.inc.php";
		if(!is_file($file)){
			$fd = @ fopen($file, "a+");
			if($fd == false){
				echo "<h3 class=\"error\">Could not create settings file ". $file ."</h3>\n";
				return "";
			}
			fwrite($fd, "<?php\ndie();\n?>");
			fclose($fd);
		}
		return $file;
	}
}
