<?php
$encoding = "utf-8";
include("presets.php");

function parseAnswer($data){
	global $encoding;
	global $localSchema;

	if(empty($data))
		return;

	# parse answer
	$doc = new DOMDocument("1.0", $encoding);
	if(!$doc->loadXML($data)){
		echo "<div class=\"log\">\n";
		echo "<div class=\"logLine\">". _("Load answer") ."<span class=\"failed\">". _("FAILED") ."</span></div>\n";
		echo "</div>\n";
		return;
	}

	# validate request
	if(!$doc->schemaValidate($localSchema)){
		echo "<div class=\"log\">\n";
		echo "<div class=\"logLine\">". _("Load answer") ."<span class=\"failed\">". _("FAILED") ."</span></div>\n";
		echo "</div>\n";
		return;
	}

	$root = $doc->getElementsByTagName("response");
	if($root->length != 1){
		echo "<div class=\"log\">\n";
		echo "<div class=\"logLine\">". _("Load answer") ."<span class=\"failed\">". _("FAILED") ."</span></div>\n";
		echo "</div>\n";
		return;
	}

	$root = $root->item(0);
	$result = $root->getElementsByTagName("result");
	if($result->length != 1){
		echo "<div class=\"log\">\n";
		echo "<div class=\"logLine\">". _("Load answer") ."<span class=\"failed\">". _("FAILED") ."</span></div>\n";
		$message = $root->getElementsByTagName("message");
		if($message->length == 1)
			echo "<div class=\"logLine\">". $message->item(0)->nodeValue ."</div>\n";
		echo "</div>\n";
		return;
	}

	$result = array();
	$manusXML = $root->getElementsByTagName("manufacturer");
	foreach($manusXML as $manu){
		$id = $manu->getElementsByTagName("id");
		if($id->length == 1){
			$id = $id->item(0)->nodeValue;
			$relevance = $manu->getElementsByTagName("relevance");
			if($relevance->length != 1)
				$relevance = 0;
			else
				$relevance = $relevance->item(0)->nodeValue;
			$name = $manu->getElementsByTagName("name");
			// the street may contain another name item
			if($name->length >= 1)
				$result[$relevance][$id] = $name->item(0)->nodeValue;
		}
	}
	return $result;
}


if(array_key_exists("searchmins", $_POST))
	$searchmins = $_POST["searchmins"];
if(!isset($searchmins))
	$searchmins = 0;
if(!is_numeric($searchmins))
	$searchmins = preg_replace("/[^0-9]+/", "", $searchmins);
if(array_key_exists("searchmanufacturer", $_POST))
	$searchmanufacturer = $_POST["searchmanufacturer"];
if(!isset($searchmanufacturer))
	$searchmanufacturer = "";

$title = _("Manufacturer and MIN ranges server");
$additionalHeader = "<link rel=\"stylesheet\" href=\"manufacturer.css\" type=\"text/css\" />\n";
include("header.php");

?>
<div class="content">
	<table>
		<tr>
			<form action="<?php
					echo $_SERVER["PHP_SELF"];
					if(!empty($lang))
						echo "?lang=". $lang;
				?>" method="post">
				<input type="hidden" name="type" value="relatedmanus">
				<td><?php echo _("MIN") .":"; ?></td>
				<td><input type="text" name="searchmins" value="<?php if($searchmins > 0) echo $searchmins; ?>"></td>
				<td><?php echo "<input type=\"submit\" name=\"submit\" value=\"". _("Find related manufacturer") ."\">"; ?></td>
			</form>
		</tr>
		<tr>
			<form action="<?php
					echo $_SERVER["PHP_SELF"];
					if(!empty($lang))
						echo "?lang=". $lang;
				?>" method="post">
				<input type="hidden" name="type" value="manu">
				<td><?php echo _("Manufacturer") .":"; ?></td>
				<td><input type="text" name="searchmanufacturer" value="<?php echo $searchmanufacturer; ?>"></td>
				<td><?php echo "<input type=\"submit\" name=\"submit\" value=\"". _("Find manufacturer") ."\">"; ?></td>
			</form>
		</tr>
	</table>
<?php
if(array_key_exists("type", $_POST)){
	include("helpers.php");
	$manus = array();
	$count = 0;
	$connId = @ mysql_connect("localhost", Settings::value("SUBMITUSER"), Settings::value("SUBMITPASSWORD"));
	if($connId){
		if(!mysql_select_db(Settings::value("DBNAME")))
			mysql_close($connId);

	if($_POST["type"] == "relatedmanus"){
		if($searchmins < 1){
			$res = mysql_query("SELECT id, name FROM manufacturers");
			$count = mysql_num_rows($res);
			$min = min($count, 20);
			for($i = 0; $i < $min; $i++){
				$manu = mysql_fetch_object($res);
				$manus[0][$manu->id] = $manu->name;
			}
		}
		else{
			# create the request for submit.php
			$doc = new DOMDocument("1.0", $encoding);
			$root = $doc->createElement("manuserver");
			$doc->appendChild($root);
			$root->setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
			$root->setAttribute("xmlns", "http://mins.engsas.de/manuserver");
			$root->setAttribute("xsi:schemaLocation", "http://mins.engsas.de/manuserver http://mins.engsas.de/manuserver.xsd");
			$request = $doc->createElement("getmanufacturersbyprefix");
			$root->appendChild($request);
			$prefix = $doc->createElement("prefix");
			$request->appendChild($prefix);
			$prefix->appendChild($doc->createTextNode($searchmins));

			$data = $doc->saveXML();

			$req = new HttpRequest("http://mins.engsas.de/submit.php", HttpRequest::METH_POST);
			$req->addBody($data);

			# parse answer
			$manus = parseAnswer($req->send()->getBody());
		}
	}
	elseif($_POST["type"] == "manu"){
			if(empty($searchmanufacturer)){
				$res = mysql_query("SELECT id, name FROM manufacturers");
				$count = mysql_num_rows($res);
				$min = min($count, 20);
				for($i = 0; $i < $min; $i++){
					$manu = mysql_fetch_object($res);
					$manus['0'][$manu->id] = $manu->name;
				}
			}
			else{
				# create the request for submit.php
				$doc = new DOMDocument("1.0", $encoding);
				$root = $doc->createElement("manuserver");
				$doc->appendChild($root);
				$root->setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance");
				$root->setAttribute("xmlns", "http://mins.engsas.de/manuserver");
				$root->setAttribute("xsi:schemaLocation", "http://mins.engsas.de/manuserver http://mins.engsas.de/manuserver.xsd");
				$request = $doc->createElement("getmanufacturersbyname");
				$root->appendChild($request);
				$name = $doc->createElement("name");
				$request->appendChild($name);
				$name->appendChild($doc->createTextNode($searchmanufacturer));

				$data = $doc->saveXML();
				$req = new HttpRequest("http://mins.engsas.de/submit.php", HttpRequest::METH_POST);
				$req->addBody($data);

				# parse answer
				$manus = parseAnswer($req->send()->getBody());
			}
		}

		echo "<div class=\"log\">\n";
		$countManus = count($manus, COUNT_RECURSIVE) - count($manus);
		if($count > 0 || $countManus > 0){
			if($count > 0){
				echo "<div class=\"logLine\">";
				printf(_('Found %1$s out of %2$s'), $countManus, $count);
				echo "<span class=\"successfull\">". _("OK") ."</span></div>\n";
			}
			else{
				echo "<div class=\"logLine\">";
				printf(_('Found %1$s'), $countManus);
				echo "<span class=\"successfull\">". _("OK") ."</span></div>\n";
			}
		}
		else
			echo "<div class=\"logLine\">". _("No entry found!") ."<span class=\"failed\">". _("FAILED") ."</span></div>\n";
		echo "</div>\n";

		if(is_array($manus)){
			foreach(array_keys($manus) as $score){
				foreach(array_keys($manus[$score]) as $id){
					$manu = new Manufacturer($manus[$score][$id]);
					$manu->loadFromId($id);
					echo $manu->toDiv($score);
				}
			}
		}
		mysql_close($connId);
	}
}

echo "	</div>\n";
include("footer.php");
?>