/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef BOOK_H
#define BOOK_H

#include "medium.h"

#include <QDate>

class Book : public Medium
{
	Q_OBJECT
	Q_PROPERTY(uint edition READ edition WRITE setEdition)
	Q_PROPERTY(uint pages READ pages WRITE setPages)
	Q_PROPERTY(QDate publicationDate READ publicationDate WRITE setPublicationDate)
	Q_PROPERTY(QString publicationPlace READ publicationPlace WRITE setPublicationPlace)
  public:
    Q_INVOKABLE Book ( EQueryThread *thread = NULL, Medium *parent = 0 );

#if QT_VERSION < 0x040500
		Medium *newMedium();
#endif
    bool select( QSqlRecord record);
    bool store(bool addOwner = false, bool startTransaction = true);
    bool setValue ( QString attribute, QVariant value );
    QVariant value ( QString attribute, int role );
		EditMedium *editWidget(EWidget* parent = 0);

    void setPages ( uint newPages );
    uint pages() const;
    void setEdition ( uint newEdition );
    uint edition() const;
    void setPublicationPlace ( QString newPlace );
    QString publicationPlace() const;
    void setPublicationDate ( QDate newDate );
    QDate publicationDate() const;

		Medium *copyMedium();
		bool exportTextTable(QTextTable *table, Medium::ExportFormat format, bool titleOnly = false);
		QString exportPlainText(Medium::ExportFormat format);

		QList<ColKeyTrans> supportedAttrs();
		
  private:
    unsigned int myPages;
    unsigned int myEdition;
    QString myPublicationPlace;
    QDate myPublicationDate;
};

#endif // BOOK_H
