/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "bookedit.h"
#include "bookedit.moc"

#include "book.h"
#include "books.h"
#include "materialpersonsmodel.h"
#include "materialperson.h"
#include <mediumsimpleeditwidget.h>
#include <mediummanufacturerwidget.h>
#include "bookeditioneditwidget.h"
#include "bookpubplaceeditwidget.h"
#include <mediumpubdateeditwidget.h>
#include "bookpageeditwidget.h"
#include <mediumpersonswidget.h>

BookEdit::BookEdit ( QWidget* parent, Qt::WindowFlags flags )
    : EditMedium ( parent, flags )
{
	setManufacturerText(tr("Publisher"));
	setPersonsDefaultRole(tr("Author"));

	insertWidget(new BookEditionEditWidget(this), "metaDataTab", "titleWidget");
	insertWidget(new BookPubPlaceEditWidget(this), "metaDataTab");
	insertWidget(new MediumPubDateEditWidget(this), "metaDataTab");
	insertWidget(new BookPageEditWidget(this), "metaDataTab");
}
