/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "books.h"
#include "books.moc"

#include "esetupwizardobject.h"
#include "esetupwizarddb.h"
#include "booksdb.h"
#include "booksmodel.h"
#include "booksearchwidget.h"
#include "book.h"
#include "searchdetailswidget.h"

#include <QtPlugin>
#include <QStringList>
#include <QIcon>

Books::Books ( ) : MediaPlugin()
{
}

Books::~Books()
{

}

bool Books::initiate ()
{
  return true;
}

bool Books::unload ()
{
  return true;
}

QString Books::name () const
{
  return tr ( "Books" );
}

QString Books::group()
{
  return "books";
}

QIcon Books::icon () const
{
  return QIcon();
}

QString Books::description () const
{
  return tr ( "Plugin is able to handle media of type book" );
}

MediaModel *Books::newModel ( QString materialType, EQueryThread *thread )
{
	Book book;
	if(materialType != book.group())
		return NULL;
  BooksModel *model = new BooksModel ( thread );
  return model;
}

Medium* Books::newMedium(QString materialType, EQueryThread* thread)
{
	Book *book = new Book(thread);
	if(materialType == book->group())
		return book;
	delete book;
	return NULL;
}

SearchDetailsWidget *Books::searchWidget ( QString materialType )
{
	Book book;
	if(materialType != book.group())
		return NULL;
  return new BookSearchWidget();
}

QStringList Books::supportedAttributes (QString materialType)
{
	Q_UNUSED(materialType);
  Book book;
  return book.supportedAttributes();
}

ESettingsModelItem *Books::settingsModelItem()
{
  return NULL;
}

ESetupWizardObject *Books::wizardObject()
{
  return new ESetupWizardDB ( tr ( "Configure Database of Books" ), new BooksDB ( ), QStringList() );
}

QStringList Books::supportedMaterialTypes()
{
	Book book;
	QStringList result;
  result << book.group();
  return result;
}

bool Books::isSupportedMaterialType(QString materialType)
{
	if(supportedMaterialTypes().contains(materialType))
		return true;
	return false;
}

QStringList Books::translateMaterialType(QString materialType)
{
	QStringList result;
	Book book;
	if(materialType != book.group())
		return result;
	result << book.name() << tr ( "All medias which are books" );
	return result;
}

QString Books::untranslateMaterialType(QString materialType)
{
	Book book;
	if(materialType != book.name())
		return QString();
	return book.group();
}

Q_EXPORT_PLUGIN2 ( Meganizer_Books, Books )
