/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef BOOKS_H
#define BOOKS_H

#include "mediaplugin.h"

#include <QIcon>

/**
  * @todo the title of books can change from one edition to the next
  */
class Books : public MediaPlugin
{
	Q_OBJECT
	Q_INTERFACES ( MediaPlugin MeganizerPlugin )
	Q_PROPERTY(QString name READ name)
	Q_PROPERTY(QString description READ description)
	Q_PROPERTY(QIcon icon READ icon)
	public:
		Books ( );
		~Books();

		bool initiate();
		bool unload();
		QString name() const;

		static QString group();

		QIcon icon() const;
		QString description() const;
		MediaModel *newModel( QString materialType, EQueryThread *thread = NULL );
		Medium *newMedium( QString materialType, EQueryThread *thread = NULL );
		SearchDetailsWidget *searchWidget( QString materialType );
		QStringList supportedAttributes( QString materialType );
		ESettingsModelItem *settingsModelItem();
		ESetupWizardObject *wizardObject();
		QStringList supportedMaterialTypes();
		bool isSupportedMaterialType(QString materialType);
		QStringList translateMaterialType(QString materialType);
		QString untranslateMaterialType(QString materialType);
};

#endif // BOOKS_H
