/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "booksimpleeditwidgettests.h"
#include "booksimpleeditwidgettests.moc"

#include "bookeditioneditwidget.h"
#include "bookpageeditwidget.h"
#include <mediumpubdateeditwidget.h>
#include "bookpubplaceeditwidget.h"

#include <QTest>

void BookSimpleEditWidgetTests::initTestCase()
{
	setTestMedium("book");
}

void BookSimpleEditWidgetTests::testWidgets()
{
	addTestObject(new BookEditionEditWidget(), "edition");
	addTestObject(new BookPageEditWidget(), "pages");
	addTestObject(new MediumPubDateEditWidget(), "publicationDate");
	addTestObject(new BookPubPlaceEditWidget(), "publicationPlace");

	baseTest();
}

QTEST_MAIN(BookSimpleEditWidgetTests)
