/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "articleedit.h"
#include "articleedit.moc"

#include "articlepagewidgets.h"
#include <mediumpubdateeditwidget.h>
#include <mediumparentswidget.h>

ArticleEdit::ArticleEdit(QWidget* parent, Qt::WindowFlags flags)
	: EditMedium(parent, flags)
{
	setManufacturerText(tr("Publisher"));
	setPersonsDefaultRole(tr("Author"));

	insertWidget(new MediumPubDateEditWidget(this), "metaDataTab");
	insertWidget(new ArticleStartPageWidget(this), "metaDataTab");
	insertWidget(new ArticleEndPageWidget(this), "metaDataTab");

	addTab(new MediumParentsWidget(this), tr("Magazines:"), "lowerTabWidget");
}

