/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "articlesmodel.h"
#include "articlesmodel.moc"

#include "article.h"
#include <delegateuser.h>

#include <QAbstractItemView>

ArticlesModel::ArticlesModel(EQueryThread* queryThread, QObject* parent)
	: MediaModel(parent)
{
	setupModel(queryThread);
}

#if QT_VERSION < 0x040500
MediaModel* ArticlesModel::createNewModel()
{
	return new ArticlesModel();
}
#endif

Medium* ArticlesModel::newMedium() const
{
	return new Article();
}

void ArticlesModel::addItemDelegates(QAbstractItemView* view)
{
	if(!view)
    return;

	Medium *medium = newMedium();
	if(!medium)
		return;

	QStringList attrs = medium->supportedAttributes();
  view->setItemDelegateForColumn(medium->attrs("owner").column, new DelegateUser(view));
	delete medium;
}
