/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MAGAZINE_H
#define MAGAZINE_H

#include <medium.h>

class ArticlesModel;

#include <QDate>

class Magazine : public Medium
{
	Q_OBJECT
	Q_PROPERTY(QString issue READ issue WRITE setIssue)
	Q_PROPERTY(QDate publicationDate READ publicationDate WRITE setPublicationDate)
	public:
		Q_INVOKABLE Magazine(EQueryThread* thread = NULL, Medium* newParent = NULL);

#if QT_VERSION < 0x040500
		Medium* newMedium();
#endif
		bool select(QSqlRecord record);
		bool prepare();
		bool store(bool addOwner = false, bool startTransaction = true);
		/**
			* To store Articles, use a QStringList with
			* @li title as QString
			* @li start page as unsigned int (may be null)
			* @li end page as unsigned int (may be null)
			* The manufacturer, genre and publication date, are set to this one.
			*/
		bool setValue(QString attribute, QVariant value);
		QVariant value(QString attribute, int role);
		QList< ColKeyTrans > supportedAttrs();
		EditMedium* editWidget(EWidget* parent = NULL);
		Medium* copyMedium();
		bool exportTextTable(QTextTable* table, Medium::ExportFormat format, bool titleOnly = false);

		void setIssue(QString issue);
		QString issue() const;
		void setPublicationDate(QDate newDate);
		QDate publicationDate() const;

	private:
		QString dbTable, myIssue;
		QDate myPubDate;
};

#endif // MAGAZINE_H
