/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MAGAZINES_H
#define MAGAZINES_H

#include <mediaplugin.h>

#include <QIcon>

class Magazines : public MediaPlugin
{
	Q_OBJECT
	Q_INTERFACES ( MediaPlugin MeganizerPlugin )
	Q_PROPERTY(QString name READ name)
	Q_PROPERTY(QString description READ description)
	Q_PROPERTY(QIcon icon READ icon)
	public:
		Magazines();

		static QString group();
		
		QString untranslateMaterialType(QString materialType);
		QStringList translateMaterialType(QString materialType);
		QStringList supportedMaterialTypes();
		bool isSupportedMaterialType(QString materialType);
		ESetupWizardObject* wizardObject();
		ESettingsModelItem* settingsModelItem();
		QStringList supportedAttributes(QString materialType);
		SearchDetailsWidget* searchWidget(QString materialType);
		MediaModel* newModel(QString materialType, EQueryThread* thread = NULL );
		Medium *newMedium( QString materialType, EQueryThread *thread = NULL );
		QString description() const;
		QIcon icon() const;
		QString name() const;
		bool unload();
		bool initiate();
};

#endif // MAGAZINES_H
