/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "magazinesdb.h"
#include "magazinesdb.moc"

#include "magazines.h"
#include "magazine.h"
#include "article.h"

void MagazinesDB::scheme()
{
	Magazines mags;
	setup(mags.group(), mags.name(), 2);

	ESqlTable *magazines = addTable ( "magazines" );
	ESqlField *field = magazines->appendField ( "materialsId", ESqlField::Integer, true );
	field->setIsUnsigned ( true );
	magazines->addForeignKey ( field->name(), "meganizer_materials", "id" );
	field = magazines->appendField ( "issue", ESqlField::Varchar, true );
	field->setLength(100);
	magazines->addIndex(field, 10);
	field = magazines->appendField( "publicationDate", ESqlField::Date );

	ESqlTable *articles = addTable ( "articles" );
	field = articles->appendField ( "materialsId", ESqlField::Integer, true );
	field->setIsUnsigned ( true );
	articles->addForeignKey ( field->name(), "meganizer_materials", "id" );
	field = articles->appendField ( "startPage", ESqlField::Integer );
	field->setLength(3);
	field = articles->appendField ( "endPage", ESqlField::Integer );
	field->setLength(3);
	field = articles->appendField ( "publicationDate", ESqlField::Date );

	ESqlTable *table = addTable ( "meganizer_materialtypes", true, false );
	table->appendField ( "name", ESqlField::Varchar );
	Magazine mag;
	QStringList insert;
	insert << "" << mag.group();
	table->appendValues ( insert );
	insert.clear();
	Article art;
	insert << "" << art.group();
	table->appendValues( insert );

	table = addTable("meganizer_materialpersonsroles", true, false);
	table->appendField("name", ESqlField::Varchar);
	table->appendField("description", ESqlField::Varchar);

	insert.clear();
	insert << "" << tr("Author") << tr("The author of the material");
	table->appendValues(insert);

	addView ( "viewmagazines",
						"SELECT  mats.*, mags.issue, mags.publicationDate"
						"  FROM "+ magazines->name() +" mags"
						"  LEFT JOIN viewmaterials mats ON mats.id=mags.materialsId");
	addView ( "viewarticles",
						"SELECT  mats.*, arts.startPage, arts.endPage, arts.publicationDate"
						"  FROM  "+ articles->name() +" arts"
						"  LEFT JOIN viewmaterials mats ON mats.id=arts.materialsId");
}

