/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "magazinesearchwidget.h"
#include "magazinesearchwidget.moc"

#include "magazines.h"

MagazineSearchWidget::MagazineSearchWidget(QWidget* parent, Qt::WindowFlags flags)
	: SearchDetailsWidget(parent, flags)
{
	setupUi(this);
	connect(pubDateEdit, SIGNAL(dateChanged(QDate)), this, SLOT(dateChanged(QDate)));
}

QString MagazineSearchWidget::searchTable()
{
	return Magazines::group() +"_viewmagazines";
}

QList< SqlConstraint > MagazineSearchWidget::constraints()
{
	QList<SqlConstraint> results;
	SqlConstraint constraint;
	if(!issueEdit->text().isEmpty()){
		constraint = SqlConstraint();
		if(issueModeEdit->currentIndex() == 1){
			constraint.setConstraint("issue=?");
			constraint.addBindValue(issueEdit->text());
		}
		else{
			constraint.setConstraint("issue LIKE ?");
			constraint.addBindValue(QString("%%1%").arg(issueEdit->text()));
		}
		results << constraint;
	}
	if(pubDate.isValid()){
		constraint = SqlConstraint();
		constraint.setConstraint(QString("publicationDate%1?").arg(conditionPubDate(pubDateModeEdit->currentIndex())));
		constraint.addBindValue(pubDate);
		results << constraint;
	}
	return results;
}

void MagazineSearchWidget::dateChanged ( QDate date )
{
	pubDate = date;
}

QString MagazineSearchWidget::conditionPubDate ( int index )
{
	switch(index){
		case 0:
			return "<=";
		case 1:
			return ">=";
		default:
			return "=";
	}
}
