/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MOVIE_H
#define MOVIE_H

#include "medium.h"

#include <QDate>

class Movie : public Medium
{
	Q_OBJECT
	Q_PROPERTY(QDate publicationDate READ publicationDate WRITE setPublicationDate)
  public:
    Q_INVOKABLE Movie ( EQueryThread *thread = NULL, Medium *parent = NULL );

#if QT_VERSION < 0x040500
 		Medium *newMedium();
#endif
    bool select( QSqlRecord record);
		bool prepare();
    bool store(bool addOwner = false, bool startTransaction = true);
    bool setValue ( QString attribute, QVariant value );
    QVariant value ( QString attribute, int role );
		EditMedium *editWidget(EWidget* parent = 0);

    void setPublicationDate ( QDate newDate );
    QDate publicationDate();
		void setDevice ( unsigned int deviceId, bool setName = true );
		void setDevice ( QString name, bool setId = true );
		void setDevice ( QSqlRecord record );
		unsigned int device() const;
		QString deviceName() const;

		Medium* copyMedium();
		bool exportTextTable(QTextTable *table, Medium::ExportFormat format, bool titleOnly = false);

		QList<ColKeyTrans> supportedAttrs();
		
  private:
		void customQueryResult(QVariant requestId, int querySize, QSqlRecord record);
		
    QDate myPublicationDate;
		unsigned int myDeviceId;
		QString myDeviceName;
};

#endif // MOVIE_H
