/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef MOVIEDEVICEEDITWIDGET_H
#define MOVIEDEVICEEDITWIDGET_H

#include <mediumeditwidget.h>
#include "ui_moviedeviceeditwidget.h"

class Movie;

class QSqlQueryModel;

class MovieDeviceEditWidget : public MediumEditWidget, private Ui::MovieDeviceEditWidget
{
	Q_OBJECT
	public:
		MovieDeviceEditWidget(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setMedium(Medium* newMedium);
    bool store(bool useExistingTransaction = false);

	private slots:
		void newDevice();

	private:
		void loadModel();
		
		QSqlQueryModel *deviceModel;
		Movie* movie;
};

#endif // MOVIEDEVICEEDITWIDGET_H
