/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "cdislpeditwidget.h"
#include "cdislpeditwidget.moc"

#include "cd.h"

#include <QCheckBox>

CDIsLPEditWidget::CDIsLPEditWidget(QWidget* parent, Qt::WindowFlags flags)
	: MediumSimpleEditWidget(CheckBox, tr("Is LP"), "isLP", parent, flags)
{
	box = qobject_cast<QCheckBox*>(editWidget());
	cd = NULL;
	origStatus = false;
}

CDIsLPEditWidget::~CDIsLPEditWidget()
{
	if(cd && modified())
		cd->setIsLP(origStatus);
}

void CDIsLPEditWidget::setMedium(Medium* newMedium)
{
	MediumSimpleEditWidget::setMedium(newMedium);
	cd = qobject_cast<CD*>(newMedium);
	if(!cd)
		return;
	origStatus = cd->isLP();
}

void CDIsLPEditWidget::setModified(bool status){
	if(cd && box)
		cd->setIsLP(box->isChecked());
	MediumSimpleEditWidget::setModified(status);
}
