/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef CDISLPEDITWIDGET_H
#define CDISLPEDITWIDGET_H

#include <mediumsimpleeditwidget.h>

class CD;

class QCheckBox;

/**
	* @brief The Is LP checkbox.
	*/
class CDIsLPEditWidget : public MediumSimpleEditWidget
{
  Q_OBJECT
  public:
    CDIsLPEditWidget(QWidget* parent = 0, Qt::WindowFlags flags = 0);
		/**
			* Since the mode must be changed directly to adapt the tracks view,
			* the destructor is used to revert the changes, if they are not saved
			* before (==> if modifed == true, they are not changed and should be reverted).
			*/
		~CDIsLPEditWidget();
		void setMedium(Medium *medium);

	protected:
		void setModified(bool status);

	private:
		QCheckBox *box;
		CD *cd;
		bool origStatus;
};

#endif // CDISLPEDITWIDGET_H