/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "cdsmodel.h"
#include "cdsmodel.moc"

#include "cd.h"
#include "delegateuser.h"
#include "cds.h"

#include <QAbstractItemView>
#include <QTableView>
#include <QSqlDatabase>
#include <QSqlQuery>

CDsModel::CDsModel ( EQueryThread *queryThread, QObject* parent ) : MediaModel ( parent )
{
	setupModel(queryThread);
	CD *item = new CD(thread);
	hideColumns << item->attrs ( "track" ).column;
	delete item;
}

#if QT_VERSION < 0x040500
MediaModel* CDsModel::createNewModel()
{
    return new CDsModel(NULL);
}
#endif

Medium *CDsModel::newMedium() const
{
  return new CD();
}

void CDsModel::addItemDelegates(QAbstractItemView* view)
{
  if(!view)
    return;
  
	Medium *medium = newMedium();
	if(!medium)
		return;
	
	QStringList attrs = medium->supportedAttributes();
  view->setItemDelegateForColumn(medium->attrs("owner").column, new DelegateUser(view));
	delete medium;
}
