/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef EDITDEVICES_H
#define EDITDEVICES_H

#include <editdialog.h>

class DetailsWidgetNameDesc;

class QSqlQueryModel;
class QSortFilterProxyModel;

class EditDevices : public EditDialog
{
	Q_OBJECT
  public:
    EditDevices ( QString name, QWidget* parent = 0, Qt::WindowFlags flags = 0 );
    EditDevices ( QWidget *parent = 0, Qt::WindowFlags flags = 0 );
    ~EditDevices();
    QString selectedName();
    unsigned int selectedId();

  private slots:
    void store();

  private:
    void init ( QString selectedName = QString() );

		QSqlQueryModel *sqlModel;
    DetailsWidgetNameDesc *myDetailsWidget;
};

#endif // EDITDEVICES_H
