/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "musicsimpleeditwidgettests.h"
#include "musicsimpleeditwidgettests.moc"

#include "cddiscseditwidget.h"
#include "cdislpeditwidget.h"
#include "tracklengtheditwidget.h"
#include "cd.h"

#include <QTest>

void MusicSimpleEditWidgetTests::testCDWidgets()
{
	addTestObject(new CDDiscsEditWidget, "discs");
	addTestObject(new CDIsLPEditWidget, "isLP");

	setTestMedium(new CD());
	baseTest();
}

void MusicSimpleEditWidgetTests::testTrackWidgets()
{
	addTestObject(new TrackLengthEditWidget, "length");

	setTestMedium("track");
	baseTest();
}

void MusicSimpleEditWidgetTests::testIsLPWidget()
{
// 	test reverting done changes
	CD *cd = new CD();
	setTestMedium(cd);
	QVERIFY(cd);
	QCOMPARE(cd->isLP(), false);
	CDIsLPEditWidget *widget = new CDIsLPEditWidget();
	widget->setMedium(cd);
	QVariant value = setValue(widget, "isLP", cd);
	QCOMPARE(value.toBool(), true);
	QVERIFY(widget->modified());
	QCOMPARE(cd->isLP(), true);
	delete widget;
	QCOMPARE(cd->isLP(), false);
}

QTEST_MAIN(MusicSimpleEditWidgetTests)
