/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "tracksmodeltest.h"
#include "tracksmodeltest.moc"

#include "tracksmodel.h"
#include "track.h"
#include <modeltest.h>

#include <QtTest/QtTest>

void TracksModelTest::testModel()
{
	baseTests(new TracksModel(0, this));
}

void TracksModelTest::switchModes()
{
	TracksModel *model = new TracksModel(0, this);
	new ModelTest(model, this);
	
	Track *track = new Track();
	track->setTitle("Test Track");
	QCOMPARE(model->addMedium(track), true);
	
	model->setMode(Track::Standard);
	QCOMPARE(model->mode(), Track::Standard);
	QCOMPARE(model->columnCount(), 5);
	QCOMPARE(model->headerData(0, Qt::Horizontal).toString(), QString("Source"));
	
	// switching to CD mode
	model->setMode(Track::CD);
	QCOMPARE(model->mode(), Track::CD);
	QCOMPARE(model->columnCount(), 5);
	QCOMPARE(model->headerData(0, Qt::Horizontal).toString(), QString("Disc"));

	// switching to LP mode
	model->setMode(Track::LP);
	QCOMPARE(model->mode(), Track::LP);
	QCOMPARE(model->columnCount(), 6);
	QCOMPARE(model->headerData(1, Qt::Horizontal).toString(), QString("Side"));
	
	// switching to collection mode
	model->setMode(Track::Collection);
	QCOMPARE(model->mode(), Track::Collection);
	QCOMPARE(model->columnCount(), 4);
	QCOMPARE(model->headerData(0, Qt::Horizontal).toString(), QString("Nr"));
}

QTEST_MAIN(TracksModelTest)
