/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef TRACKTEST_H
#define TRACKTEST_H

#include <mediumbasetests.h>

#include <dbtestinit.h>

class Medium;

#include <QPointer>
#include <QVariant>

// to allow QTest::addColumn<QVariant>("")
Q_DECLARE_METATYPE(QVariant);

class TrackTest : public MediumBaseTests
{
	Q_OBJECT
	private slots:
		void initTestCase();
		void fetchMessages(QString msg);
		
		void testExtendedProperties();
		void copyTrack();
		void insertAndLoadExtendedProperties();
		void switchModes();
		void tracksHandling();
		void extentedSetValueAndValue();
		
	private:
		void connectMedium(Medium *med);
		
		QPointer<DBTestInit> testInit;
		MediumKeys keys;
		unsigned int testMedId;
};

#endif // TRACKTEST_H
