/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef TRACKSMODEL_H
#define TRACKSMODEL_H

#include "mediamodel.h"

#include "track.h"

class TracksModel : public MediaModel
{
	Q_OBJECT
  public:		
    Q_INVOKABLE TracksModel ( EQueryThread *queryThread, QObject *parent = 0 );

#if QT_VERSION < 0x040500
		MediaModel *createNewModel();
#endif
    Medium *newMedium() const;
		bool loadChilds(Medium *parent);
    void addItemDelegates(QAbstractItemView *view);
		
		virtual Qt::ItemFlags flags ( const QModelIndex& index ) const;
		/**
			* @brief Sets the mode of this model and all handled tracks.
			*
			* @see Track::Mode
			*/
		void setMode(Track::Mode mode);
		Track::Mode mode() const;
		
	private:
		void doAddMedium(Medium *med);

		Track::Mode myMode;
};

#endif // TRACKSMODEL_H
