/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef CATEGORYMODEL_H
#define CATEGORYMODEL_H

#include <QAbstractItemModel>

class Category;

#include <QModelIndex>

class CategoryModel : public QAbstractItemModel
{
	Q_OBJECT
	public:
		CategoryModel(QObject *parent = 0);
		~CategoryModel();
		
		void addCategory(QString name, Category *parent = 0);
		void addCategory(Category *cat, Category *parent = 0);
		QModelIndex indexOfItem(Category *category) const;
		Category *itemFromIndex(QModelIndex index) const;
		
    QVariant data(const QModelIndex& index, int role = Qt::DisplayRole) const;
    int columnCount(const QModelIndex& parent = QModelIndex()) const;
    int rowCount(const QModelIndex& parent = QModelIndex()) const;
    QModelIndex parent(const QModelIndex& child) const;
    QModelIndex index(int row, int column, const QModelIndex& parent = QModelIndex()) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;
		
	private slots:
		void catChanged(Category *category);
		
	private:
		QList<Category*> items;
};

#endif // CATEGORYMODEL_H
