/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef CHECKMANUFACTURERSSTATUSDIALOG_H
#define CHECKMANUFACTURERSSTATUSDIALOG_H

#include <edialog.h>
#include "ui_checkmanufacturersstatusdialog.h"

class CheckManufacturers;

/**
	* @brief The dialog to display the progress of the manufacturer number cycle checks.
	* 
	* It uses CheckManufacturers to execute all checks threaded.
	*/
class CheckManufacturersStatusDialog : public EDialog, private Ui::CheckManufacturersStatusDialog
{
	Q_OBJECT
	public:
		CheckManufacturersStatusDialog(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		~CheckManufacturersStatusDialog();
		
	public slots:
    int exec();
	
	private slots:
		void setOverallRange(int max);
		void overallIncrease();
		void setMINType(QString typeName);
		void setMINTypeRange(int max);
		void setStep(QString text);
		void minTypeIncrease();
		void log(QString msg);
		void finished(bool result);
		
	private:
		CheckManufacturers *check;
		bool dataSend;
};

#endif // CHECKMANUFACTURERSSTATUSDIALOG_H
