/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DBINIT_H
#define DBINIT_H

#include <esqlinit.h>

typedef bool (*updateRoutine)(QString&);

/**
  * class holds the database structure and
  * creates it, if needed
  */
class DBInit : public ESqlInit
{
    Q_OBJECT
  public:
    DBInit ( QObject *parent = 0,
						 QString username = QString(), QString host = QString(),
						 QString database = QString(), QString driver = QString(),
						 QString password = QString() );

  private:
    /**
      * holds the structure for MedienDB main application
      */
    void scheme();
		static bool updateFrom3To4(ESqlInit* caller, QList<ESqlTable*> tables, QString &errorString);
		static bool updateFrom5To6(ESqlInit* caller, QList<ESqlTable*> tables, QString &errorString);
		static bool updateFrom6To7(ESqlInit* caller, QList<ESqlTable*> tables, QString &errorString);
		static bool updateFrom7To8(ESqlInit* caller, QList<ESqlTable*> tables, QString &errorString);
		static bool updateFrom9To10(ESqlInit* caller, QList<ESqlTable*> tables, QString &errorString);
		static bool updateFrom10To11(ESqlInit* caller, QList< ESqlTable* > tables, QString& errorString);

};

#endif // DBINIT_H
