/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef INSERTMANUALMEDIA_H
#define INSERTMANUALMEDIA_H

#include <edialog.h>
#include "ui_insertmanualmedia.h"

#include <medium.h>

class MediaModel;

/**
	* Let the user choose all media which source is one of origins and which is not
	* in database already
	* @attention default origins is only set to Medium::Manual
	*/
class InsertManualMedia : public EDialog, private Ui::InsertManualMedia
{
	Q_OBJECT
	public:
		InsertManualMedia(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		/**
			* To set origins to other than Medium::Manual, it must be called before setupMedia()
			*/
		void setUnsavedOrigins(Medium::Origins origins);
		void setupMedia(MediaModel *srcModel);
		void setupMedia(QList<Medium*> media);
		
	public slots:
		int exec();
		
	private slots:
		void ok();
		
	private:
		Medium::Origins origins;
		MediaModel *model;
		
};

#endif // INSERTMANUALMEDIA_H
