/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "loansummary.h"

#include <loanmodel.h>
#include <esqldatabase.h>
#include <etableview.h>

#include <QVBoxLayout>
#include <QSqlQuery>
#include <QSqlRecord>

LoanSummary::LoanSummary(QWidget *parent, Qt::WindowFlags flags)
	: EWidget(parent, flags)
{
	setObjectName("loanSummary");
	setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);
	
	QVBoxLayout *mainLayout = new QVBoxLayout(this);
	setLayout(mainLayout);
	view = new ETableView(this);
	mainLayout->addWidget(view);
	view->setSizePolicy(QSizePolicy::MinimumExpanding, QSizePolicy::MinimumExpanding);
	
	model = new LoanModel(0, this);
	connect(model, SIGNAL(error(QString)), this, SLOT(errorByPass(QString)));
	connect(model, SIGNAL(warning(QString)), this, SLOT(warningByPass(QString)));
	connect(model, SIGNAL(information(QString)), this, SLOT(informationByPass(QString)));
	view->setModel(model);
	model->addItemDelegates(view);
	model->hideAndResizeColumns(view);
}

LoanSummary::~LoanSummary()
{
	close();
	model->store();
	delete model;
	delete view;
}

#include "loansummary.moc"
