/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "manufacturerrange.h"

ManufacturerRange::ManufacturerRange(uint manufacturersId, uint mintypesId, QString prefix)
{
	setManufacturerId(manufacturersId);
	setMinTypesId(mintypesId);
	setPrefix(prefix);
}

bool ManufacturerRange::isValid()
{
	if(manufacturerId() < 1)
		return false;
	if(mintypesId() < 1)
		return false;
	if(prefix().isEmpty())
		return false;
	return true;
}

void ManufacturerRange::setManufacturerId(uint id)
{
	myManuId = id;
}

uint ManufacturerRange::manufacturerId()
{
	return myManuId;
}

void ManufacturerRange::setMinTypesId(uint id)
{
	myMinTypesId = id;
}

uint ManufacturerRange::mintypesId()
{
	return myMinTypesId;
}

void ManufacturerRange::setPrefix(QString prefix)
{
	myPrefix = prefix;
}

QString ManufacturerRange::prefix()
{
	return myPrefix;
}
