/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef PROJECTS_H
#define PROJECTS_H

#include <ewidget.h>
#include "ui_projects.h"

class ProjectsModel;
class Project;
class Medium;
class MediaModel;

#include <QModelIndex>

class QSortFilterProxyModel;

class Projects : public EWidget, private Ui::Projects
{
	Q_OBJECT
	public:
		Projects(QWidget *widget = 0, Qt::WindowFlags flags = 0);
		~Projects();
		
	protected:
		void closeEvent(QCloseEvent *event);
		
	private slots:
		void newProject();
		void store();
		void projectChanged(QModelIndex index);
		void resultSearch();
		void resultClear();
		void materialAdd();
		void materialRemove();
		void materialChanged(QModelIndex index);
		void filter(QString fitlerString);
		void clearProjectDetails();
		void help();
		
	private:
		ProjectsModel *model;
		QSortFilterProxyModel *proxyModel;
		QModelIndex projIndex, matIndex;
		Medium *resultMedium;
		MediaModel *materialsModel;
		Project *currentProject;
};

#endif // PROJECTS_H
