/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef SETTINGSGENERAL_H
#define SETTINGSGENERAL_H

#include <esettingswidget.h>

class EDBSettings;
class SetupUserWidget;

#include <QSettings>
#include <QCloseEvent>

namespace Ui {
    class SettingsGeneral;
}

/**
  * @todo provide tooltip entrys for each setting
  */
class SettingsGeneral : public ESettingsWidget {
  Q_OBJECT
  public:
    SettingsGeneral(QWidget *parent = 0, Qt::WindowFlags flags = 0);
    ~SettingsGeneral();
		static QStringList sqlDrivers();

  public slots:
		/**
			* sendMINRanges should be only saved, if it is changed
			* manually. Otherwise, the user may not notice this feature,
			* save the settings (means sendMINRanges=false) and is never asked again.
			* To make sure that he is asked on first occurance, sendMINRanges is only saved,
			* if it is changed by the user (see sendMINRangesChanged and mySendMINRangesChanged).
			*/
    bool saveSettings(QString &error);

  protected:
    void changeEvent(QEvent *e);

  private slots:
    void loadSettings();
		void sendMINRangesChanged();

  private:
    QSettings qSettings;
    Ui::SettingsGeneral *m_ui;
		EDBSettings *dbSettings;
		SetupUserWidget *userWidget;
		bool mySendMINRangesChanged;

  signals:
    void ready();
};

#endif // SETTINGSGENERAL_H
