/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "setupuserwidget.h"
#include "setupuserwidget.moc"

#include <edituserdetailswidget.h>
#include <esqldatabase.h>
#include "meganizer.h"

#include <QHBoxLayout>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QSqlError>

SetupUserWidget::SetupUserWidget ( ESetupWizardObject* newObject, QWidget* parent, Qt::WindowFlags flags )
    : ESetupWizardWidget ( newObject, parent, flags )
{
  QHBoxLayout *mainLayout = new QHBoxLayout(this);
	setLayout(mainLayout);
	userWidget = new EditUserDetailsWidget(this);
	mainLayout->addWidget(userWidget);
	connectByPass(userWidget);
	userWidget->setUserNameNeeded();

  setName ( tr ( "Create your user" ) );
  userWidget->setUserNameReadOnly ( true );
	ESqlDatabase db = ESqlDatabase::database();
	userWidget->setUserName ( db.userName() );
	bool closeDB = !db.isOpen();
  if ( db.open() ) {
    QSqlQuery query ( QString ( "SELECT id, name, givenName, email FROM "+ Meganizer::group() +"_users WHERE userName='%1'" ).arg ( db.userName() ) );
    query.exec();
    if ( query.first() ) {
      userWidget->setId(query.record().value ( "id" ).toUInt());
      userWidget->setName ( query.record().value ( "name" ).toString() );
      userWidget->setGivenName ( query.record().value ( "givenName" ).toString() );
      userWidget->setEmail ( query.record().value ( "email" ).toString() );
    }
    if(closeDB)
			db.close();
  }
}

SetupUserWidget::~SetupUserWidget()
{
	delete userWidget;
}

bool SetupUserWidget::saveSettings(QString& error)
{
	return finish();
}

bool SetupUserWidget::finish()
{
  return userWidget->store();
}

void SetupUserWidget::showEvent(QShowEvent* event)
{
	ESqlDatabase db = ESqlDatabase::database();
	userWidget->setUserName ( db.userName() );
	QWidget::showEvent(event);
}

