/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "shoppingcartlistview.h"

#include <QKeyEvent>

ShoppingCartListView::ShoppingCartListView(QWidget *parent)
	: QListView(parent)
{
	connect(this, SIGNAL(clicked(QModelIndex)), this, SLOT(setIndex(QModelIndex)));
}

void ShoppingCartListView::keyPressEvent(QKeyEvent* event)
{
	if(!index.isValid()){
		QListView::keyPressEvent(event);
		return;
	}
	switch(event->key()){
		case Qt::Key_Minus:
			emit decrease(index);
			break;
		case Qt::Key_Plus:
			emit increase(index);
			break;
		case Qt::Key_Delete:
			emit remove(index);
			break;
		default:
			QListView::keyPressEvent(event);
	}
}

void ShoppingCartListView::setIndex(QModelIndex index)
{
	this->index = index;
}

#include "shoppingcartlistview.moc"
