/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#include "projectsmodeltest.h"

#include <projectsmodel.h>
#include "modeltest.h"
#include <project.h>
#include <medium.h>

#include <QtTest/QtTest>
#include <QSqlRecord>

ProjectsModelTest::ProjectsModelTest(QObject* parent): QObject(parent)
{
	model = new ProjectsModel(this);
	modeltest = new ModelTest(model, this);
}

ProjectsModelTest::~ProjectsModelTest()
{
	delete modeltest;
	delete model;
}

void ProjectsModelTest::testModel()
{
	QList<Project*> items;
	items << new Project();
	items << new Project();
	items[items.size() - 1]->setName("Test");
	items << new Project();
	items[items.size() - 1]->setName("Test 1");
	items[items.size() - 1]->setId(12);
	items[items.size() - 1]->addMaterial(0);
	items[items.size() - 1]->addMaterial(QSqlRecord());
	items << new Project();
	items[items.size() - 1]->setName("Test 2");
	items[items.size() - 1]->setId(12);
	items[items.size() - 1]->addMaterial(new Medium());
	items[items.size() - 1]->setDescription("Super Project");
	
	// insert mins
	foreach(Project *project, items){
		model->addProject(project);
	}
	
	QCOMPARE(model->rowCount(), items.size());
	
	// remove a min from the beginning, the middle and the end
	if(model->rowCount() > 0)
		model->removeRow(0);
	
	if(model->rowCount() > 0)
		model->removeRow(model->rowCount() - 1);
	
	if(model->rowCount() > 2){
		int half = model->rowCount() / 2;
		model->removeRow(half);
	}
}

QTEST_MAIN(ProjectsModelTest)

#include "projectsmodeltest.moc"
