/*
 *  Meganizer - Media Organzier is a media management software
 *  Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "testmeganizerepart.h"

#include "testmeganizerepart.moc"

#include <epluginloader.h>
#include <epart.h>

#include <QTest>
#include <QApplication>
#include <QString>
#include <QDir>

void TestMeganizerEPart::testepart()
{
  QDir path = QDir(QApplication::applicationDirPath());
  QString partName = "";

#ifdef Q_OS_WIN32
  partName = "meganizer.dll";
#else
  partName = "meganizer.so";
  path.cd("../lib");
#endif

  // check if target is considered
  QVERIFY(partName != QString());
	
  EPart *theEpart = EPluginLoader<EPart>::loadPlugin(partName, path.absolutePath());

  QVERIFY(theEpart);

  testEParts(theEpart);
}

QTEST_MAIN(TestMeganizerEPart)