/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010 - 2011 EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


#ifndef EANVALIDATOR_H
#define EANVALIDATOR_H

#include <minvalidatorplugin.h>

#include <QString>

class EANValidator : public MINValidatorPlugin
{
	Q_OBJECT
  Q_INTERFACES ( MINValidatorPlugin )
  Q_PROPERTY(QString name READ type)
  Q_PROPERTY(QString description READ description)
	public:
		EANValidator();
		
    QString type() const;
		QString description() const;
		bool canConvert(QString toType) const;
		QString convert(QString min, QString toType) const;
		bool isValid(QString min) const;
		QString validate(QString min) const;
		bool isType(QString min) const;
		bool mayType(QString min) const;
		QString strip(QString min) const;
		QStringList commonPrefixes(QStringList mins) const;
		QStringList minMaxPrefixes(QString min) const;
		
		bool operator== (const MINValidatorPlugin &plugin) const;
		bool operator!= (const MINValidatorPlugin &plugin) const;
		
	private:
		int checksum(QString min) const;
		/**
			* @brief Compares each min out of @p mins with any other min and returns the first found prefix.
			* 
			* It uses commonPrefix(QString, QString) to get the prefix of two mins.
			*/
		QString commonPrefix(QStringList mins) const;
		/**
			* @brief Determines the prefix of @p min1 and @p min2.
			*/
		QString commonPrefix(QString min1, QString min2) const;
};

#endif // EANVALIDATOR_H
