/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef AMAZONGENERALSETTINGS_H
#define AMAZONGENERALSETTINGS_H

#include "esetupwizardwidget.h"

#include <QWidget>

class QGridLayout;
class QLineEdit;
class QComboBox;
class QSpinBox;
class QDoubleSpinBox;
class QCheckBox;

#include <QMultiMap>

class AmazonGeneralSettings : public ESetupWizardWidget {
  Q_OBJECT

  public:
    AmazonGeneralSettings(ESetupWizardObject *object = 0, QWidget *parent = 0, Qt::WindowFlags flags = 0);
    ~AmazonGeneralSettings();
    bool saveSettings(QString &error);

  private:
    QGridLayout *mainLayout;
    QLineEdit *token, *secret;
    QComboBox *locale, *buyingModes;
    QSpinBox *maxPages;
		QDoubleSpinBox *minFeedbackRating;
		QCheckBox *logWindowEdit;
		QMultiMap<int, QString> mapBuyingOrder;
};

#endif // AMAZONGENERAL_H
