/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "amazonsettings.h"
#include "amazonsettings.moc"

#include "amazon.h"
#include "amazongeneralsettings.h"
#include "amazonconntypesettings.h"
#include "connectmediasearchsettings.h"

#include <QVBoxLayout>
#include <QTabWidget>

AmazonSettings::AmazonSettings(Amazon *amazon, QWidget* parent, Qt::WindowFlags flags)
				: ESettingsWidget(parent, flags)
{
  setName(tr("Amazon Settings"));
	QVBoxLayout *myLayout = new QVBoxLayout(this);
	setLayout(myLayout);
	
	tabWidget = new QTabWidget(this);
	myLayout->addWidget(tabWidget);
	
	// adding widgets
	AmazonGeneralSettings *aGen = new AmazonGeneralSettings(0, tabWidget);
	connectByPass(aGen);
	tabWidget->addTab(aGen, aGen->name());
	
	AmazonConnTypeSettings *aType = new AmazonConnTypeSettings(amazon, tabWidget);
	connectByPass(aType);
	tabWidget->addTab(aType, aType->name());
	
	ConnectMediaSearchSettings *connMed = new ConnectMediaSearchSettings(amazon, tabWidget);
	connectByPass(connMed);
	tabWidget->addTab(connMed, connMed->name());
}

AmazonSettings::~AmazonSettings() 
{
	for(int i = 0; i < tabWidget->count(); i++){
		QWidget *widget = tabWidget->widget(i);
		tabWidget->removeTab(i);
		widget->deleteLater();
	}
	tabWidget->deleteLater();
}

bool AmazonSettings::saveSettings(QString& error) 
{
	bool result = true;
	for(int i = 0; i < tabWidget->count(); i++){
		ESettingsWidget *widget = qobject_cast<ESettingsWidget*>(tabWidget->widget(i));
		if(!widget)
			continue;
		if(!widget->saveSettings(error)){
			result = false;
		}
	}
	return result;
}
