/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "configamazon.h"

#include "amazonsetupobject.h"
#include "amazonsetupobject.moc"

#include "amazon.h"
#include "amazongeneralsettings.h"

#include <QSettings>

AmazonSetupObject::AmazonSetupObject(QObject* parent)
  : ESetupWizardObject(parent)
{
	addWidget(new AmazonGeneralSettings(this));
}

bool AmazonSetupObject::finish(ESetupWizardWidget* finishWidget)
{
	QString msg;
  return finishWidget->saveSettings(msg);
}

bool AmazonSetupObject::needed()
{
  bool result = false;
  QSettings settings;
  settings.beginGroup(Amazon::group());
  if((settings.value("token").toString().isEmpty()) && (QString ( AWSACCESSKEY ) == "na"))
    result = true;
	if((settings.value("secret").toString().isEmpty()) && (QString ( AWSSECRET ) == "na"))
    result = true;
  if(settings.value("locale").toString().isEmpty())
    result = true;
  settings.endGroup();
  return result;
}
