/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef CONNECTMATERIALTYPE_H
#define CONNECTMATERIALTYPE_H

#include <esettingswidget.h>
#include "ui_connectmaterialtype.h"

class SearchPlugin;
class Medium;

class ConnectMaterialType : public ESettingsWidget, private Ui::ConnectMaterialType
{
	Q_OBJECT
	public:
		/**
			* @param mediaModel the model which should be connected
			* @param searchPlugin the search plugin which categories should be connected to mediaModel
			*/
		ConnectMaterialType(Medium *medium, SearchPlugin *searchPlugin, QWidget *parent = 0, Qt::WindowFlags flags = 0);
		ConnectMaterialType(QWidget *parent = 0, Qt::WindowFlags flags = 0);
		void setPlugins(QString modelGroup, SearchPlugin* searchPlugin);
		void setPlugins(Medium *medium, SearchPlugin *searchPlugin);
		QString category();
		bool loadSettings();
		
	public slots:
		bool saveSettings(QString &error);
		
	private:
		QString mediumGroup;
		SearchPlugin *searchPlugin;
		QMap<QString, QString> mapTypes;
		
	signals:
		void rejected();
};

#endif // CONNECTMATERIALTYPE_H
