/*
    Meganizer - Media Organzier is a media management software
    Copyright (C) 2010  EngSaS - Engineering Solutions and Services Langenbach. All rights reserved.

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef ITEMSEARCH_H
#define ITEMSEARCH_H

#include <QString>
#include <QStringList>
#include <QtCrypto>
#include <QNetworkRequest>

class ItemSearch {
  public:
    ItemSearch(QString awsKey = QString(), QString awsSecret = QString());
		~ItemSearch();
    void setIndex(QString string);
    void setKeyword(QString string);
    void setTitle(QString string);
    void setCreator(QString string);
    void setManufacturer(QString string);
    void setEan(QString string);
		bool addItem(QString offerListingId, int quantity);
		void setOfferMode(bool enable = true);
		void setCartCreateMode(bool enable = true);
		void setCartAddMode(QString cartId, QString cartHmac, bool enable = true);
		void setCartGetMode(QString cartId, QString cartHmac, bool enable = true);
		void setDebugging(bool enable = true);
		/**
			* @param timeStamp is mainly for testing functionality
			*/
    QString getRequest(int page = 1, QString timeStamp = QString());
		QNetworkRequest netRequest();
    bool isEmpty();
		bool checkQCA();
		bool keysSet();

  private:
    QString prepareIndex(bool sign = false);
    QString prepareKeyword(bool sign = false);
    QString prepareTitle(bool sign = false);
    QString prepareCreator(bool sign = false);
    QString prepareManufacturer(bool sign = false);
    QString prepareEan(bool sign = false);
		QString prepareOffers(bool sign = false);
    QString responseGroups(bool sign = false);
    
		/**
			* @param timeStamp is mainly for testing puproses
			*/
    QString soapHeader(QString timeStamp = QString());
    QString soapFooter();
    QString timestamp();
    QString signature(QString timestamp);
		QString associateId(QString locale);
    
		QCA::SecureArray token, secret;
    QString locale;
    QString searchIndex;
    QStringList keywords;
    QString title;
    QString creator;
    QString manufacturer;
    QString ean;
		QMap<QString, int> offerItems;
		bool offerMode, cartCreateMode, cartAddMode, cartGetMode, debuggingMode;
		QString cartId, cartHmac;
		QCA::Initializer init;
};
#endif
